#!/usr/bin/perl

use CGI;
use CGI::Carp "fatalsToBrowser";
require "./config.pl";		#please ALTER THE GLOBALS HERE
require $PRASI_FULL_URL;
require "./common.pl";

#################################################################################
# Wefis Version 1.5, December 2006
# 
# This programmed was created by Franois Botman, and is released under the terms of the GPL license...
# If you wish to use parts of the code in your own applications, please place a link to the source, and email me to inform me what you've used
# (just to encourage me to continue)...
#
# This file contains routines to deal with any 'action' that involves the server part...
##################################################################################
$form = new CGI;
$a=$form->param('action');
$p=$form->param('param');

if(!$a) {error("${TRANS_this_script_was_called_without_specifying_any_action__quitting_}");}	#of enormous debugging value!!!

if($a eq "help") {
	list_help_docs();
	print "<OK>";
}
elsif($a eq "openhelp") {
	$p =~ s/\.\.\//_/gi;	# somewhat more secure...
	$help = "./docs/$p";
	open (HLP,"< $help") or error("${TRANS_the_specified_help_file_could_not_be_found}.");
	@image=<HLP>;
	close HLP;
	print @image;
	exit;
}
elsif($a eq "theme_copyright") {
	if(!-e "${THEME_ROOT_PATH}/$iconset/theme.pl") {$s = "default";}	#default to default if not found...
	if(!do "${THEME_ROOT_PATH}/$iconset/theme.pl") {print "Theme does not contain this information.";exit;}	#on error!!
	print "<OK>\n${THEME_AUTHOR}";
	exit;
}
elsif($a eq "create_file") {
	checkFullQuota();
	$path = checkPath($p);
	$path =~ s/\.\./_/g;
	
	$dir = clean_path("$path/../");
	if(!-e $dir) {sleep 5;}		#Directory may not have been created yet!!
	checkDirExists($dir);
	
	open(TAM,"> $path") or error("${TRANS_could_not_create_the_requested_file__permission_denied_}<BR>$path");
	if($path =~ /index.html$/) {print (TAM "${TRANS_wefis_generated_index_file__hides_valuable_data_from_prying_browsers___}");}
	else {print (TAM " ");}
	close TAM;
	chmod oct("0755"), "$path";
	print "<OK>";
}

elsif($a eq "create_dir") {
	$path = checkPath($p);
	$path =~ s/\.\./_/g;
	checkDirExists($path);
	print "<OK>\n";
}

elsif($a eq "rename") {
	$from = checkPath($p);
	$from =~ s/\.\./_/g;
	$to=$form->param('to');
	$to = checkPath($to);
	$to =~ s/\.\./_/g;
	checkDirExists("$to/../");
	if(!rename "$from", "$to") {print "${TRANS_could_not_rename_the_requested_item__permission_denied_}<BR>$from";exit;}
	print "<OK>";
}
elsif($a eq "delete") {
	$path = checkPath($p);
	$path =~ s/\.\./_/g;
	
	if(-d $path) {
		delete_dirs($path);
		if(!rmdir "$path") {print "${TRANS_could_not_delete_the_requested_directory__permission_denied_}<BR>$path";exit;}
	}
	else {		#Normal file!
		if(!unlink "$path") {print "${TRANS_could_not_delete_the_requested_file__permission_denied_}<BR>$path";exit;}
	}
	print "<OK>";
}

elsif($a eq "chmod") {
	$path = checkPath($p);
	$path =~ s/\.\./_/g;
	$to = $form->param('to');
	chmod oct($to), "$path";
	print "<OK>";
}

elsif($a eq "copy") {
	checkFullQuota();
	$path = checkPath($p);
	$path =~ s/\.\./_/g;
	$to = $form->param('to');
	$to = checkPath($to);
	$to =~ s/\.\./_/g;
	checkDirExists("$to/../");
	if(system(checkSystem("cp -r \"$path\" \"$to\"")) != 0) {print "${TRANS_these_files_could_not_be_copied_}<BR>$!";exit;}
	print "<OK>";
}
elsif($a eq "fulledit") {
	$file = checkPath($p);
	if(!-e $file) {print "${TRANS_the_specified_file_could_not_be_found_on_the_server}!!<BR>It may still be being created...";exit;}
	print "<HTML><HEAD><TITLE>${TRANS_editing_file_} $p</TITLE></HEAD><BODY>";
	print "<SCRIPT src=\"${JS_URL}/lang/main_english.js\"></SCRIPT>";
	print "<SCRIPT src=\"${JS_URL}/lang/data_english.js\"></SCRIPT>";
	print '<SCRIPT>window.onresize=resized;function resized(){scrollTo(0,0);var y = window.innerHeight ? window.innerHeight :document.body.clientHeight;if(document.getElementById(\'content_full\')) document.getElementById(\'content_full\').style.height=Math.max(20,y-60);}';
	print '</SCRIPT><DIV id="send" name="send" style="visibility: hidden;"></DIV><DIV id="d8er" name="d8er">';
	print "<FORM action=\"javascript:saveFile('content_full','$p',2);\">";
	print '<textarea name="content_full" id="content_full" style="width:100%;">';
	#insert data here ;-)
	open (USER,"< $file");
	@userdat=<USER>;
	close USER;
	foreach $eon (@userdat) {$eon =~ s/<\/textarea>/\&lt;\/textarea\&gt;/gi;print "$eon";}
	
	print "</TEXTAREA><BR> <input type=button value=\"${TRANS_save}\" onclick=\"writeDiv('send','<CENTER><B><BR>${TRANS_please_wait__saving_file}');saveFile('content_full','$p',-1);\"> <input type=submit value=\"${TRANS_save_close}\" onclick=\"changeDiv('d8er','hidden');writeDiv('send','<CENTER><B><BR>${TRANS_please_wait__saving_file}');\"> ";
	print "<INPUT TYPE=hidden name=\"file\" id=\"file\" value=\"$p\">";
	print " | <a href=\"#\" onClick=\"window.close();\">${TRANS_cancel}</a></FORM></DIV><SCRIPT>resized();</SCRIPT></BODY></HTML>";
}
elsif($a eq "edit") {
	checkFullQuota();
	$file = checkPath($p);
	$confirm = $form->param('confirm');
	if(!-e $file) {print "${TRANS_the_specified_file_could_not_be_found_on_the_server}!!<BR>It may still be being created...";exit;}
	if(((-s $file)>(500*1024)) and ($confirm ne "true")) {print "<confirmlargefile>";exit;}	#larger files than 500kb are paused...
	
	#Is there a plugin??
	my @bits = split(/\./, $file);
	my $ext = pop(@bits);
	if((-e "./plugins/$ext.edit") and ($penabled eq "true")) {$plugin_file = $file;if(require "./plugins/$ext.edit") {
		print "<OK><BR><BR><CENTER><a href=\"#\" onClick=\"browseTo('',getFileName(\'$p\'));\">${TRANS_cancel}</a></CENTER>";
		exit;
	}}
	
	#otherwise, use default renderer...
	if($file =~ /\.(cgi|txt|html|htm|shtml|dhtml|css|pl|py|c|h|prj|xml|js|java|php|cc|cpp)$/) {}
	else {print "${TRANS_editing_these_filetypes_is_not_yet_explicitly_supported____br_it_is_possible_that_the_default_viewer_would_render_corrupted_text__if_so__click} <A HREF=\"#\" onclick=\"browseTo();\">${TRANS_here}</A>.<BR><BR>";}
	
	print "<form method=post action=\"javascript:saveFile('content','$p',1);\"><INPUT TYPE=hidden name=\"file\" id=\"file\" value=\"$p\">";
	print "\n<textarea name=\"content\" id=\"content\" rows=\"20\" cols=\"70\">";
	
	open (USER,"< $file");
	@userdat=<USER>;
	close USER;
	foreach $eon (@userdat) {$eon =~ s/<\/textarea>/\&lt;\/textarea\&gt;/gi;print "$eon";}
	print "</textarea>\n\n<br><OK>\n";
	print "<input type=button value=\"${TRANS_save}\" onclick=\"saveFile('content','$p',0);\"> ";
	print "<input type=submit value=\"${TRANS_save_close}\" onclick=\"busy('${TRANS_please_wait__saving_file}');\"> ";
	print " | <a href=\"#\" onClick=\"browseTo('',getFileName(\'$p\'));\">${TRANS_cancel}</a>";
	print " | <a href=\"#\" onClick=\"Edit_FullScreen();\">${TRANS_fullscreen}</a>";
	print "</FORM>";
}

elsif($a eq "addFav") {
	$what = $form->param('param');
	(my $favcnt)=prasi_data($u,"${SERVICE_NAME}_FAVITEMCNT");
	if(!$favcnt) {$favcnt=0;}
	chomp($favcnt);
	
	my $favcntvar = 0;
	while($favcntvar < $favcnt) {
		($favitem)=prasi_data($u,"${SERVICE_NAME}_FAVITEM_$favcntvar");
		chomp($favitem);
		if($favitem eq $what) {error("${TRANS_a_favorite_item_already_exists_for_this_location____cannot_set_another_one_}");}
		$favcntvar++;
	}
	prasi_save($u,"${SERVICE_NAME}_FAVITEM_${favcnt}",$what,$SERVICE_NAME);
	$favcnt++;
	prasi_save($u,"${SERVICE_NAME}_FAVITEMCNT",$favcnt,${SERVICE_NAME});
	print "<OK>";
}

elsif($a eq "removeFav") {
	my $favdelname = $form->param('param');
	(my $favcnt)=prasi_data($u,"${SERVICE_NAME}_FAVITEMCNT");
	if(!$favcnt) {error("${TRANS_cannot_remove_favourite__item_cnt_is_empty__}");}
	chomp($favcnt);
	
	#remove item by shifting up...
	my $favcntvar = 0;
	my $favcnt2 = 0;
	while($favcntvar < $favcnt) {
		($favitem)=prasi_data($u,"${SERVICE_NAME}_FAVITEM_${favcntvar}");
		chomp($favitem);
		prasi_save($u,"${SERVICE_NAME}_FAVITEM_${favcnt2}",$favitem,$SERVICE_NAME);
		$favcntvar++;
		if($favitem ne $favdelname) {$favcnt2++;}
	}
	prasi_save($u,"${SERVICE_NAME}_FAVITEM_${favcnt2}",$favitem,$SERVICE_NAME);
	$favcnt--;
	prasi_save($u,"${SERVICE_NAME}_FAVITEMCNT",$favcnt,$SERVICE_NAME);
	print "<OK>";
}

elsif($a eq "multi") {		#All multimode goes here!
	$data = $form->param('data');
	$action = $form->param('param');
	$to = $form->param('to');
	$ok = "1";
	
	if($action eq "delete") {
		@bits = split(/\|/,$data);
		foreach $f (@bits) {
			if(!$f) {next;}
			if(!unlink checkPath($f)) {$f = checkPath($f);print "${TRANS_could_not_delete_the_following_file_} $f<BR>";$ok="0";}
		}
		if($ok eq "1") {print "<OK>";}
	}
	elsif($action eq "chmod") {
		@bits = split(/\|/,$data);
		foreach $f (@bits) {
			if(!$f) {next;}
			if(!(chmod oct($to), checkPath($f))) {$f = checkPath($f);print "${TRANS_could_not_chmod_the_following_file_} $f<BR>";$ok="0";}
		}
		if($ok eq "1") {print "<OK>";}
	}
	elsif($action eq "copy") {
		checkFullQuota();
		if(!($to =~ /\/$/)) {$to.="/";}
		$to = checkPath($to);
		$to =~ s/\.\./_/g;
		if(!-e $to) {mkdir $to;}
		if(!-e $to) {print "${TRANS_could_not_create_the_directory_to_copy_to__}";exit;}
		@bits = split(/\|/,$data);
		$request = "cp";
		foreach $f (@bits) {
			if(!$f) {next;}
			$f = checkPath($f);
			if(-e $f) {$request.=" \"$f\"";}
		}
		$request.=" \"$to\"";
		if(system(checkSystem($request)) != 0) {print "${TRANS_these_files_could_not_be_copied_} $!<BR>";exit;}
		print "<OK>";
	}
	elsif($action eq "move") {
		$to = checkPath($to);
		$to =~ s/\.\./_/g;
		if(!($to =~ /\/$/)) {$to.="/";}
		if(!-e $to) {mkdir $to;}
		if(!-e $to) {print "${TRANS_could_not_create_the_directory_to_move_to__}";exit;}
		@bits = split(/\|/,$data);
		$request = "mv";
		foreach $f (@bits) {
			if(!$f) {next;}
			$f = checkPath($f);
			if(-e $f) {$request.=" \"$f\"";}
		}
		$request.=" \"$to\"";
		if(system(checkSystem($request)) != 0) {print "${TRANS_these_files_could_not_be_moved_} $! , $f<BR>";exit;}
		print "<OK>";
	}
	elsif($action eq "download") {
		$to_orig = $to;
		$to = checkPath($to);		#This is our current directory!!
		$to =~ s/\.\./_/g;
		if(!-e $to) {print "${TRANS_the_specified_target_directory_does_not_exist__}";exit;}
		$demand = "cd \"${to}\" && tar -cvzf \"${to}___wefis_created_download___.tar.gz\" ";
		$regex1 = "${to_orig}";
		@bits = split(/\|/,$data);
		foreach $f (@bits) {
			if(!$f) {next;}
			if(!/"/gi) {
				$f =~ s/$regex1//;
				$f = clean_path($f);
				$demand .= "\"./$f\" ";
			} #avoid potential exploits of 'added bits' using && by checking for file existence for every parameter! -> is put in quotes so is safe...?
		}
		print "<PRE>";
		if(system($demand) != 0) {print "</PRE><BR>${TRANS_these_files_could_not_be_downloaded_} $! , $f<BR><PRE>";exit;}
		print "</PRE><OK><BR><BR>${TRANS_you_can_download_the_file_here_} <A HREF=\"${DOC_URL}${to_orig}___wefis_created_download___.tar.gz\">${TRANS_download_link}</A><BR><BR>";
	}
	else {
		checkFullQuota();
		if((-e "./plugins/$action.multi") and ($penabled eq "true")) {			#Run a plugin...
			@bits = split(/\|/,$data);
			foreach $f (@bits) {
				if(!$f) {next;}
				$f = checkPath($f);
				$plugin_file = $f;
				$plugin_action = "run";
				$plugin_param = $to;
				$plugin_descr = $action;
				if(!do "./plugins/$action.multi") {error("${TRANS_the_plugin_has_crashed_or_suffered_some_form_of_malfunction___}");}
			}
			print "<OK>";
		}
		else {print "${TRANS_the_plugin_for_the_requested_action_was_not_found__br_please_verify_that_it_is_properly_configured_}";}
	}
}

elsif($a eq "savefile") {		#All filesaving goes here!
	$data = $form->param('data');
	$path = checkPath($p);
	$path =~ s/\.\./_/g;
	
	$dir = clean_path("$path/../");
	if(!-e $dir) {sleep 5;}		#Directory may not have been created yet!!
	
	$data =~ s/\@SPECIALPLUSSYMBOL\@/+/g;		#replace wrong/invalid symbols...
	open(TAM,"> $path") or error("${TRANS_could_not_edit_the_requested_file__permission_denied_}<BR>$path");
	print(TAM "$data");
	close TAM;
	print "<OK>";
}

elsif($a eq "fullscr") {		#doesn't do much; just creates a page from the right domain (security on some systems)...
	print "<HTML><HEAD><TITLE>...</TITLE></HEAD><BODY></BODY></HTML>";
}

elsif($a eq "extract_file") {
	checkFullQuota();
	$path = checkPath($p);
	$path =~ s/\.\./_/g;

	$dir="$path/../";
	$dir =~ s/\/+/\//g;			#remove double /'s...
	$dir = clean_path($dir);

	if($path =~ /\.tar\.gz$/) {if(system(checkSystem("tar -xvzf \"$path\" -C \"$dir\""))!=0) {print "${TRANS_error_extracting_files___}";}}
	elsif($path =~ /\.tar$/) {if(system(checkSystem("tar -xvf \"$path\" -C \"$dir\""))!=0) {print "${TRANS_error_extracting_files___}";}}
	elsif($path =~ /\.zip$/) {if(system(checkSystem("unzip \"$path\" -d \"$dir\""))!=0) {print "${TRANS_error_extracting_files___}";}}
	else {print "${TRANS_this_archive_type_is_not_known__}";exit;}
	print "<OK>";	#if successfull only!!
}

elsif($a eq "getdatabase") {
	list_raw_data("");
}
elsif($a eq "getpreview") {
	preview(clean_path($p));
}
elsif($a eq "userinfochange") {
	my $user = prasi_login("prasi_manager",0);	#change to prasi_manager!!!
	if(!$user) {error("${TRANS_you_have_insufficient_privileges_to_edit_this_user_s_profile__you_must_be_an_administrator_}");}
	$us = $form->param('user');
	my $quot = $form->param('quota');
	my $hd = $form->param('hm');
	my $guest = $form->param('guest');
	my $bul = $form->param('baseurl');
	
	prasi_save($us,"${SERVICE_NAME}_quota",$quot,"${SERVICE_NAME}");
	prasi_save($us,"${SERVICE_NAME}_home_directory",$hd,"${SERVICE_NAME}");
	prasi_save($us,"${SERVICE_NAME}_home_url",$bul,"${SERVICE_NAME}");
	prasi_save($us,"${SERVICE_NAME}_to_admin","",${SERVICE_NAME});
	prasi_save($us,"${SERVICE_NAME}_guest_user",$guest,${SERVICE_NAME});
	print "<OK>";
	$a = "admin";	#redirect input to the admin control panel!
}

elsif($a eq "addnewuser") {
	if($wefis_guest eq "true") {error("${TRANS_you_are_a_guest_user__guest_users_have_no_rights_}");}
	print"<H1>${TRANS_add_new_users_to_prasi}</H1><BR><TABLE WIDTH=500><TR><TD>${TRANS_please_follow_the_following_steps_to_add_new_users_to_prasi_}<BR><SMALL>${TRANS_a_few_windows_will_be_opened_for_each_processs__as_wefis_contacts_prasi__most_are_non_essential__though_a_few_provide_extra_options_for_the_new_user___}</SMALL><BR><BR>
	<OL><LI><B>${TRANS_fill_out_this_form_}</B><BR><DIV id=step1 name=step1>
		${TRANS_full_name}: <input type=text id=addusername name=addusername><br>
		${TRANS_username}: <input type=text id=adduseruser name=adduseruser> ${TRANS__b_note__b___only_characters_a_z__a_z_and_0_9_}<br>
		${TRANS_email}: <input type=text id=adduseremail name=adduseremail><br>
		<input type=button onclick=\"changeDiv('step1','hidden');window.open('${PRASI_URL}/manage.cgi?name='+ElementValue('addusername')+'&user='+ElementValue('adduseruser')+'&email='+ElementValue('adduseremail')+'&action=newuser&closewindow=yes');\" value=\"${TRANS_create_user}\"></DIV></LI>
	
	<LI><B>${TRANS_add_user_to_prasi_}</B><BR><DIV id=step2 name=step2>
		<A HREF=\"#\" onclick=\"writeDiv('step2','${TRANS__done_}');window.open('${PRASI_URL}/manage.cgi?target='+ElementValue('adduseruser')+'&service=prasi&action=addservice&closewindow=yes');\">${TRANS_wefis_can_do_this_for_you_}</A>
	</DIV>
	</LI>
	<LI><B>${TRANS_add_user_to_wefis_}</B><BR><DIV id=step3 name=step3>
		<A HREF=\"#\" onclick=\"window.open('${PRASI_URL}/manage.cgi?target='+ElementValue('adduseruser')+'&service=$SERVICE_NAME&action=addservice&closewindow=yes');writeDiv('adminop','<TABLE WIDTH=400><TR><TD><CENTER>${TRANS__b_user_added__b___br_please_change_the_options_opened_in_the_external_window___}</CENTER><BR></TD></TR></TABLE>');\">${TRANS_wefis_can_do_this_for_you_}</A>
	</DIV>
	</LI></TD></TR></TABLE><OK>";
}
elsif($a eq "mailuser-send") {
	if($wefis_guest eq "true") {error("${TRANS_you_are_a_guest_user__guest_users_cannot_email_the_admin_via_this_system___}");}
	$mail=$form->param('mail');
	$user=$form->param('user');
	prasi_save($user,"${SERVICE_NAME}_from_admin",$mail,${SERVICE_NAME});
	print "<OK><B>${TRANS_mail_sent_to_the_user}...</B><BR><BR>";
	$a = "admin";
}

elsif($a eq "contactuser") {
	my $user = prasi_login("prasi_manager",0);	#change to prasi_manager!!!
	if(!$user) {error("${TRANS_you_have_insufficient_privileges_to_edit_this_user_s_profile__you_must_be_an_administrator_}");}
	$us = $form->param('user');
	
	print "<H1>${TRANS_contact_user}</H1>";
	print "<TABLE width=500><TR><TD>${TRANS_this_interface_allows_you_to_contact_this_user_from_within_wefis__br_reasons_for_doing_so_include_announcing_changes__quota_increases_____}<BR><BR><CENTER><textarea name=\"usermail\" id=\"usermail\" rows=\"15\" cols=\"30\">${TRANS_please_enter_your_message_here_}</TEXTAREA></CENTER></TD></TR><TR><TD><BR><BR><CENTER>";
	print "<OK><INPUT TYPE=button value=\"${TRANS_send_mail}\" onclick=\"fetch('list','mailuser-send&mail='+ElementValue('usermail')+'&user=$us');\"></CENTER></TD></TR></TABLE><BR><BR>";
}


elsif($a eq "saveset") {
	my $t=$form->param('indexf');
	$indexfile=$t;
	prasi_save($u,"${SERVICE_NAME}_index_file",$t,${SERVICE_NAME});
	$t=$form->param('plug');
	$penabled=$t;
	prasi_save($u,"${SERVICE_NAME}_plugins_enabled",$t,${SERVICE_NAME});
	$t=$form->param('tool');
	$m_toolbar=$t;
	prasi_save($u,"${SERVICE_NAME}_minimised_toolbar",$t,${SERVICE_NAME});
	$t=$form->param('compat');
	prasi_save($u,"${SERVICE_NAME}_compatibility_upload",$t,${SERVICE_NAME});
	$t=$form->param('theme');
	prasi_save($u,"${SERVICE_NAME}_home_icons",$t,${SERVICE_NAME});
	print "<OK>";
}

if($a eq "mailadmin-send") {
	if($wefis_guest eq "true") {error("${TRANS_you_are_a_guest_user__guest_users_cannot_email_the_admin_via_this_system___}");}
	$mail=$form->param('mail');
	prasi_save($u,"${SERVICE_NAME}_to_admin",$mail,${SERVICE_NAME});
	print "<OK>";
}

elsif($a eq "mailadmin") {
	if($wefis_guest eq "true") {error("${TRANS_you_are_a_guest_user__guest_users_cannot_email_the_admin_via_this_system___}");}
	print "<H1>${TRANS_contact_admin}</H1>";
	if($ADMIN_MAIL_DISABLED ne "no") {error("${TRANS_the_administrator_of_this_system_has_decided_to_disable_this_messaging_system__if_you_still_want_to_contact_the_admin__you_should_do_so_from_prasi_}");}
	(my $m) = prasi_data($u,"${SERVICE_NAME}_to_admin");
	chomp($m);
	if($m) {
		$m =~ s/</ &lt /gi;
		$m =~ s/>/ &gt /gi;
		$m =~ s/\\/\n/gi;
		print "<TABLE width=500><TR><TD>${TRANS__b_you_have_already_sent_a_mail_to_the_administrator___b__but_it_has_not_yet_been_read_or_processed__and_so_you_can_still_change_it_}<BR></TD></TR><TR><TD><CENTER><textarea name=\"adminmail\" id=\"adminmail\" rows=\"10\" cols=\"30\">$m</TEXTAREA></CENTER></TD></TR><TR><TD><BR><BR><CENTER>";
	}
	else {
		print "<TABLE width=500><TR><TD>${TRANS_this_interface_allows_you_to_contact_your_administrator__br_reasons_for_doing_so_include_problem_reporting__quota_upgrade_requests__etc_}<BR><BR><CENTER><textarea name=\"adminmail\" id=\"adminmail\" rows=\"15\" cols=\"30\">${TRANS_please_enter_your_request_here_}</TEXTAREA></CENTER></TD></TR><TR><TD><BR><BR><CENTER>";
	}
	print "<INPUT TYPE=button value=\"${TRANS_send_mail}\" onclick=\"sendData('mailadmin-send&mail='+ElementValue('adminmail'),'null','${TRANS_mail_sent}');browseTo();\"> <INPUT TYPE=button value=\"${TRANS_cancel}\" onclick=\"browseTo();\"></CENTER></TD></TR></TABLE><OK>";
}

elsif($a eq "userinfo") {
	my $user = prasi_login("prasi_manager",0);	#change to prasi_manager!!!
	if(!$user) {error("${TRANS_you_have_insufficient_privileges_to_edit_this_user_s_profile__you_must_be_an_administrator_}");}
	$us = $form->param('user');
	(my $quot)=prasi_data($us,"${SERVICE_NAME}_quota");
	(my $hd)=prasi_data($us,"${SERVICE_NAME}_home_directory");
	(my $uul) = prasi_data($us,"${SERVICE_NAME}_home_url");
	print "<H1>${TRANS_more_info_for_user} $us:</H1>";
	print "<FORM name=userinfo id=userinfo><TABLE width=600>";
	print "<TR><TD><B>${TRANS_username_}</B></TD><TD>$us</TD></TR>";
	print "<TR><TD><B>${TRANS_user_quota_} (Mb)</B></TD><TD><INPUT type=\"text\" name=\"qta\" id=\"qta\" value=\"$quot\" size=10></TD></TR>";
	print "<TR><TD><B>${TRANS_user_home_directory_}</B></TD><TD><INPUT type=\"text\" name=\"home\" id=\"home\" value=\"$hd\" size=60></TD></TR>";
	print "<TR><TD><B>${TRANS_user_base_url_}</B></TD><TD><INPUT type=\"text\" name=\"baseurl\" id=\"baseurl\" value=\"$uul\" size=60></TD></TR>";
	print "<TR><TD><B>${TRANS_other}</B></TD> <TD><A HREF=\"#\" onclick=\"if(confirm('${TRANS_are_you_sure_that_you_wish_to_remove_this_user_from_wefis_}')) {writeDiv('adminop','<TABLE WIDTH=400><TR><TD><CENTER>${TRANS_user_removed_from_wefis}</CENTER><BR></TD></TR></TABLE>'); window.open('${PRASI_URL}/manage.cgi?target=$us&service=$SERVICE_NAME&action=delservice&closewindow=yes');}\">${TRANS_remove_from_wefis}</A><BR>";
	print "<A HREF=\"#\" onclick=\"if(confirm('${TRANS_____warning______nthis_will_completely_eradicate_this_user_from_the_entire_prasi_system__are_you_sure_you_know_what_you_are_doing_}')) {writeDiv('adminop','<TABLE WIDTH=400><TR><TD><CENTER>${TRANS_user_removed_from_prasi}</CENTER><BR></TD></TR></TABLE>');window.open('${PRASI_URL}/manage.cgi?target=$us&action=deluser&closewindow=yes');}\">${TRANS_remove_from_prasi}</A><BR>";
	print "<INPUT TYPE=checkbox name=guestcheck id=guestcheck ";
	(my $mg) = prasi_data($us,"${SERVICE_NAME}_guest_user");
	chomp($mg);
	if($us eq $u) {print "DISABLED";}
	else {if($mg eq "true") {print "CHECKED";}}
	print "> Guest user?</TD></TR>";
	print "</TABLE><BR><BR>";
	(my $m) = prasi_data($us,"${SERVICE_NAME}_to_admin");
	chomp($m);
	if($m) {
		$m =~ s/</ &lt /gi;
		$m =~ s/>/ &gt /gi;
		$m =~ s/\n/<BR>/gi;
		$m =~ s/\r/<BR>/gi;
		print "<fieldset><legend>${TRANS_message_from_this_user_}</legend><CENTER><TABLE width=400><TR><TD>$m</TD></TR></TABLE></CENTER><HR><BR><SMALL>This message will now be considered read, and will be removed from this menu...</SMALL></fieldset><BR><BR>";
	}
	print "<CENTER><INPUT TYPE=button value=\"${TRANS_submit_changes}\" onclick=\"fetch('list','userinfochange&baseurl='+ElementValue('baseurl')+'&user=$us&quota='+ElementValue('qta')+'&guest='+document.userinfo.guestcheck.checked+'&hm='+ElementValue('home'));\">";
	print "<INPUT TYPE=button value=\"${TRANS_contact_user}\" onclick=\"fetch('adminop','contactuser&path=$location&user=$us');\"></CENTER><BR><BR></FORM><OK>";
}
if($a eq "admin") {
	my $user = prasi_login("prasi_manager",0);	#change to prasi_manager!!!
	if(!$user) {error("${TRANS_you_have_insufficient_privileges_to_edit_this_user_s_profile__you_must_be_an_administrator_}");}
	print "<OK><DIV name=\"adminop\" id=\"adminop\" width=\"580\"><H1>${TRANS_admin_control_panel}</H1><fieldset><legend>${TRANS_user_management_}</legend>";
	$list = prasi_userlist("${SERVICE_NAME}");
	@wefis_users = split(/\n/, $list);
	print "<B>${TRANS_users_currently_using_wefis_}</B><BR><BR><SMALL><CENTER>${TRANS_please_click_on_an_item_to_edit_it___}</SMALL></CENTER><BR><TABLE WIDTH=550><TR><TD><B>${TRANS_name_}</B> </TD><TD><B>${TRANS_quota_}</B></TD><TD><B><CENTER>${TRANS_home_}</CENTER> </B></TD><TD><B>${TRANS_access_}</B></TD></TR>";
	foreach $us (@wefis_users) {
		(my $quot)=prasi_data($us,"${SERVICE_NAME}_quota");
		(my $hd)=prasi_data($us,"${SERVICE_NAME}_home_directory");
		(my $m) = prasi_data($us,"${SERVICE_NAME}_to_admin");
		(my $wg) = prasi_data($us,"${SERVICE_NAME}_guest_user");
		chomp($quot);
		chomp($hd);
		chomp($m);
		chomp($wg);
		print "<TR onmouseover=\"this.style.backgroundColor='#F5F5F5';\" onmouseout=\"this.style.backgroundColor='#FFFFFF';\" onclick=\"changeDiv('admincnt','visible');fetch('adminop','userinfo&user=$us');\">";
		print "<TD>";
		if($m && !($m =~ m/quota/i)) {print "<IMG SRC=\"./themes.cgi?icon=mail\" border=0>";}
		print "$us </TD><TD><CENTER>$quot Mb";
		if($m && $m =~ m/quota/i) {print " <IMG SRC=\"./themes.cgi?icon=mail\" border=0>";}		#quota icons appears next to the quota!!
		print "</CENTER></TD>";
		print "<TD>$hd</TD>";
		print "<TD><CENTER>";
		if($us eq $u) {print "${TRANS_admin}";}
		else {
			if($wg eq "true") {print "${TRANS_guest}";}
			else {print "${TRANS_full}";}
		}
		print "</CENTER></TD></TR>\n";
	}
	print "</TABLE><BR><HR><BR>";
	
	print "<B>${TRANS_add_users_to_wefis_}</B><BR>\n";
	$list = prasi_userlist("");
	@prasi_users = split(/\n/, $list);
	print "${TRANS_you_can_add_the_following_users_to_wefis_} <SELECT id=\"addusr\" name=\"addusr\" onchange=\"if((document.getElementById('addusr').selectedIndex!=0) && confirm('${TRANS_are_you_sure_you_want_to_add} '+document.getElementById('addusr').options[document.getElementById('addusr').selectedIndex].text+' ${TRANS_to_this_service_}')) {changeDiv('admincnt','visible'); window.open('${PRASI_URL}/manage.cgi?target='+document.getElementById('addusr').options[document.getElementById('addusr').selectedIndex].text+'&service=$SERVICE_NAME&action=addservice&closewindow=yes'); writeDiv('adminop','<TABLE WIDTH=400><TR><TD><CENTER>${TRANS__b_user_added__b___br_please_change_the_options_opened_in_the_external_window___}</CENTER><BR></TD></TR></TABLE>');}\">";
	print "<OPTION>${TRANS__none_}</OPTION>";
	CANDIDATE: foreach $us (@prasi_users) {
		foreach $to (@wefis_users) {if($to eq $us) {next CANDIDATE;}}	#Is this user already in wefis? If so, hide them!
		print "<OPTION>$us</OPTION>";
	}
	print "</SELECT>\n<BR><BR>${TRANS_if_you_wish_to_add_other_new_users_to_the_system__please_follow_the_following_link_} <A HREF=\"#\" onclick=\"changeDiv('admincnt','visible');fetch('adminop','addnewuser');\">${TRANS_show_steps___}</A>
	</fieldset><BR><BR>
	<CENTER><A HREF=\"http://wefis.sf.net/cgi-bin/latest.cgi?lang=english&this=${Wefis_Version}&domain=$WEFIS_DOMAIN\"><IMG src=\"http://wefis.sf.net/cgi-bin/latest.cgi?ulogo=true&lang=english&this=${Wefis_Version}&domain=$WEFIS_DOMAIN\" BORDER=0></A></CENTER>
	</DIV><DIV name=\"admincnt\" id=\"admincnt\" style=\"visibility: hidden;\"><CENTER><a href=\"#\" onClick=\"changeDiv('admincnt','hidden');fetch('list','admin');\">${TRANS_click_here_to_go_back___}</A></CENTER></DIV><BR><CENTER><A HREF=\"#\" onclick=\"browseTo();\">${TRANS_close}</A></CENTER><BR>";
}

exit;
