/********************************************************************************************
	Secondary Javascript file for Wefis 1.4
	Written in April 2006
	This file is an integral part of Wefis, and code herein is licensed under GPL.
	If you use code in these files, please keep the following lines in the code:
	
	Programmed by Franois Botman from Wefis (http://wefis.sf.net).
	If you find bugs, please report them here: franchie@users.sourceforge.net
***********************************************************************************************/

/**********************************************************************************************
	Data.js; contains all the functions to synchronise data with the server (ajax data transmission).
	Some are general functions, others are async, etc..
	Dependancies; ajax.js, main.js
**********************************************************************************************/

var currentop = 'Current action: -';
var update_timer= (5*60*1000);				//reload contents occasionally...


function getHttpObj() {
	var http;
	try {
		http=new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
		try {
			http=new ActiveXObject("Microsoft.XMLHTTP");
		} catch (e) {
			if (!http && typeof XMLHttpRequest!='undefined') {
				try {
					http = new XMLHttpRequest();
				} catch (e) {
					http=false;
				}
			}
			else http=false;
		}
	}
	return http;
}

/* Called when the operation times out, but when we still need to try to reconnect...*/
function OnOperationTimeOut(action,data,txt,cnt) {
	if(cnt>0) {
		writeDiv('reload','Retrying in '+cnt+' seconds...');
		setTimeout('OnOperationTimeOut(\''+action+'\',\''+data+'\',\''+txt+'\','+(cnt-1)+');',1000);		//set the next timer!!!
	}
	else {
		writeDiv('reload','<I>Reloading...</I>');
		sendData(action,data,txt);
	}
}

/* Same thing, but for the checkbox upload function......*/
function OnOperationTimeOutCheck(action,data,parm,cnt) {
	if(!document.getElementById('reload')) return;
	if(cnt>0) {
		writeDiv('reload','Retrying in '+cnt+' seconds...');
		setTimeout('OnOperationTimeOutCheck(\''+action+'\',\''+data+'\',\''+parm+'\','+(cnt-1)+');',1000);		//set the next timer!!!
	}
	else {
		writeDiv('reload','<I>Reloading...</I>');
		checkBoxData(action,data,parm);
	}
}

/* Same thing, but for the file save function......*/
function OnOperationTimeOutSave(textareaname,file,close,cnt) {
	if(!document.getElementById('reload')) return;
	if(cnt>0) {
		writeDiv('reload','Retrying in '+cnt+' seconds...');
		setTimeout('OnOperationTimeOutSave(\''+textareaname+'\',\''+file+'\',\''+close+'\','+(cnt-1)+');',1000);		//set the next timer!!!
	}
	else {
		writeDiv('reload','<I>Reloading...</I>');
		saveFile(textareaname,file,close);
	}
}

/*Sends one piece of data to action.cgi?action=[whatever], param=[whatever]...*/
function sendData(action,data,txt) {
	currentop = 'Curent Operation:\nNotifying server of local file changes...';
	if(!data || !action) return;
	var xmlhttp = getHttpObj();		//get a new AJAX object per call !!
	
	if(!xmlhttp) {alert('invalid xmlhttp object!! Are you sure your browser supports it?');return;}
	changeDiv('bgactivity','visible');
	showError();
	
	var fs_time = (new Date()).getTime();
	var send = "./action.cgi?time="+fs_time+'&action='+action+'&param='+data;
	
	xmlhttp.open("GET",send,true);
	xmlhttp.setRequestHeader("charset", "ISO-8859-1");
	//waiting...?
	xmlhttp.onreadystatechange=function() {
		try {
			if (xmlhttp.readyState==4) {
				if(xmlhttp.status == 200) {
					var t=xmlhttp.responseText;
					changeDiv('bgactivity','hidden');
					if(!t.match(/<ok>/gi)) showError('Failed to complete the requested action: permission denied.<BR><SMALL><PRE>'+t+'</PRE></SMALL>');
					else {
						if(txt) success(txt);
						if(action=='extract_file') updateRawData(true,true);
					}
				}
				else {		//failure (also timeout!)...
					showError('Connection timed out');
					OnOperationTimeOut(action,data,txt,20);
				}
			}
		} catch(e) {
			showError('Connection timed out');
			OnOperationTimeOut(action,data,txt,20);
		}
	}
	xmlhttp.send(null);
}






/*This function sends the checkbox data to the server, and displays the result...*/
function checkBoxData(action,data,parm) {
	currentop = 'Curent Operation:\nUploading filenames for multi-mode action: '+action;
	if(!data || !action) return;
	var xmlhttp = getHttpObj();		//get a new AJAX object per call !!
	
	if(!xmlhttp) {alert('invalid xmlhttp object!! Are you sure your browser supports AJAX?');return;}
	changeDiv('bgactivity','visible');
	showError();
	
	var fs_time = (new Date()).getTime();
	var send = "./action.cgi";
	
	writeDiv('list','<TABLE width="500"><TR><TD>[Please wait: Your request is being processed...]</TD></TR></TABLE><BR>');
	busy('Please wait, sending data to server...');
	
	xmlhttp.open("POST",send,true);			//POST? yes: we can send more data this way!
	xmlhttp.setRequestHeader("charset", "ISO-8859-1");
	//xmlhttp.setRequestHeader("Content-type", "text/html");
	xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');	//IMPORTANT!!
	xmlhttp.onreadystatechange=function() {
		try {
			if (xmlhttp.readyState==4) {
				if(xmlhttp.status == 200) {
					var t=xmlhttp.responseText;
					changeDiv('bgactivity','hidden');
					if(!t.match(/<ok>/gi)) {
						showError('Failed to complete the requested action: permission denied.<BR><SMALL><PRE>'+t+'</PRE></SMALL>');
						writeDiv('list','<TABLE width="500"><TR><TD><IMG SRC="./themes.cgi?icon=warn" BORDER=0></TD><TD>An error occurred during the processing of your request... You may find more details about this error here:<BR><B>'+t+', </B><I>'+xmlhttp.statusText+'('+xmlhttp.status+')</I><BR><A HREF="javascript:browseTo();">Continue...</A></TD></TR></TABLE><BR>');
					}
					else writeDiv('list','<TABLE width="500"><TR><TD><IMG SRC="./themes.cgi?icon=ok" BORDER=0></TD><TD><B>Operation Completed Successfully!</B><BR>'+t+'<BR></TD></TR><TR><TD><CENTER><A HREF="javascript:modeSwitch();browseTo();">Continue...</A></CENTER></TD></TR> </TABLE><BR>');		//add a link forward?
					updateRawData(true);	//update databse in visible mode (we are out of sync here!!)
				}
				else {		//failure (also timeout!)...
					showError('Connection timed out');
					OnOperationTimeOutCheck(action,data,parm,20);
				}
			}
		} catch(e) {
			showError('Connection timed out');
			OnOperationTimeOutCheck(action,data,parm,20);
		}
	}
	xmlhttp.send("time="+fs_time+'&action=multi&param='+action+'&data='+data+'&to='+parm);		//send data via this thing!!
}


/*This function saves the contents of a file...*/
//close (=0 from normal window) (=1 save and close) (=2 from fullscreen save and close) (-1 from fullscreen save)
function saveFile(textareaname,file,close) {
	currentop = 'Curent Operation:\nSaving the edited file...';
	if(!textareaname || !file) return;
	var xmlhttp = getHttpObj();		//get a new AJAX object per call !!
	changeDiv('bgactivity','visible');
	
	if(!xmlhttp) {alert('invalid xmlhttp object!! Are you sure your browser supports AJAX?');return;}
	if(!close) changeDiv('bgactivity','visible');
	if(!close) busy('Please wait:\nSaving file...');		//non-interactive saving!!
	
	var fs_time = (new Date()).getTime();
	var send = "./action.cgi";
	
	xmlhttp.open("POST",send,true);			//POST? yes: we can send more data this way!
	xmlhttp.setRequestHeader("charset", "ISO-8859-1");
	//xmlhttp.setRequestHeader("Content-type", "text/html");
	xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');	//IMPORTANT!!
	xmlhttp.onreadystatechange=function() {
		try {
			if (xmlhttp.readyState==4) {
				changeDiv('bgactivity','hidden');
				busy();
				if(xmlhttp.status == 200) {
					var t=xmlhttp.responseText;
					if(!close) changeDiv('bgactivity','hidden');
					if(!close) busy();
					if(!t.match(/<ok>/gi)) {
						if(close==0 || close==1) showError('Failed to complete the requested action: permission denied.<BR><SMALL><PRE>'+t+'</PRE></SMALL>');
						//if(!close) writeDiv('list','<TABLE width="500"><TR><TD><IMG SRC="./themes.cgi?icon=warn" BORDER=0></TD><TD>An error occurred during the processing of your request... You may find more details about this error here:<BR><B>'+t+', </B><I>'+xmlhttp.statusText+'('+xmlhttp.status+')</I><BR></TD></TR></TABLE><BR>');
						else alert('Failed to complete the requested action: permission denied.<BR><SMALL><PRE>'+t+'</PRE></SMALL>');
					}
					else {
						if(close==0) success('File Saved');
						else if(close==1) {success('File Saved');browseTo();}
						else if(close==2) {writeDiv('send','<CENTER><BR><BR><B><I>File Saved!</I></B></CENTER>');setTimeout('window.close();',500);}
						else {writeDiv('send','<CENTER><BR><BR><B><I>File Saved!</I></B></CENTER>');setTimeout('writeDiv("send"," ");',1000);}
					}
				}
				else {		//failure (also timeout!)...
					changeDiv('bgactivity','hidden');
					showError('Connection timed out');
					OnOperationTimeOutSave(textareaname,file,close,20);
				}
			}
		} catch(e) {
			changeDiv('bgactivity','hidden');
			showError('Connection timed out');
			OnOperationTimeOutSave(textareaname,file,close,20);
		}
	}
	
	var data = getData(textareaname);
	data=escape(data);
	data=data.replace(/\+/g,'@SPECIALPLUSSYMBOL@');			//catch wierd things which are wrongly encoded!
	xmlhttp.send("time="+fs_time+'&action=savefile&param='+file+'&data='+data);		//send data via this thing!!
}



/*This function downloads a new copy of the local database... about once every 5-10 minutes, soas not to burden the server too heavily!*/
function updateRawData(noninteractive,refresh) {
	if(!document.getElementById('raw')) return;		//we are probably in fullmode editing!
	currentop = 'Curent Operation:\nDownloading updated copy of local database from file server!...';
	var xmlhttp = getHttpObj();		//get a new AJAX object per call !!
	
	if(!xmlhttp) {alert('invalid xmlhttp object!! Are you sure your browser supports it?');return;}
	changeDiv('bgactivity','visible');
	if(noninteractive) busy('Updating local file database from server...<BR>Please wait...');
	
	var fs_time = (new Date()).getTime();
	var send = "./action.cgi?time="+fs_time+'&action=getdatabase';
	
	xmlhttp.open("GET",send,true);
	xmlhttp.setRequestHeader("charset", "ISO-8859-1");
	xmlhttp.onreadystatechange=function() {
		try {
			if (xmlhttp.readyState==4) {
				if(xmlhttp.status == 200) {
					var t=xmlhttp.responseText;
					changeDiv('bgactivity','hidden');
					if(t) {setData('raw',t);if(refresh) browseTo();}
					if(noninteractive || refresh) busy();
				}
				else {changeDiv('bgactivity','hidden');if(noninteractive) showError('The server did not respond to the listing request...<BR>Wefis cannot maintain sync!<BR>Please check your connection and reload wefis!');}
			}
		} catch(e) {changeDiv('bgactivity','hidden');if(noninteractive) showError('The server did not respond to the listing request...<BR>Wefis cannot maintain sync!<BR>Please check your connection and reload wefis!');}
	}
	xmlhttp.send(null);
	if(!noninteractive) setTimeout('updateRawData()',update_timer);
}
setTimeout('updateRawData()',update_timer);


/*This function downloads the file contents for it to be edited...!*/
function edit(file,confirm) {
	currentop = 'Curent Operation:\nDownloading file contents...';
	var xmlhttp = getHttpObj();		//get a new AJAX object per call !!
	
	if(!xmlhttp) {alert('invalid xmlhttp object!! Are you sure your browser supports it?');return;}
	changeDiv('bgactivity','visible');
	
	var fs_time = (new Date()).getTime();
	var send = "./action.cgi?time="+fs_time+'&action=edit&param='+file+'&confirm='+confirm;
	writeDiv('list','<DIV name="keepgoing" id="keepgoing"><CENTER>Loading...</CENTER></DIV>');
	
	xmlhttp.open("GET",send,true);
	xmlhttp.setRequestHeader("charset", "ISO-8859-1");
	xmlhttp.onreadystatechange=function() {
		try {
			if (xmlhttp.readyState==4) {
				changeDiv('bgactivity','hidden');
				if(xmlhttp.status == 200) {
					var t=xmlhttp.responseText;
					if(t && document.getElementById('keepgoing') && !t.match(/<confirmlargefile>/gi)) {writeDiv('list',t);}
					else if(xmlhttp.responseText.match(/<confirmlargefile>/gi)) {
						writeDiv('list','<DIV name="keepgoing" id="keepgoing"></DIV><DIV name="pausegoing" id="pausegoing"></DIV><CENTER><IMG src="./themes.cgi?icon=loading" border=0><BR><BR>The file you are attempting to edit is rather large, and will probably take some time to download...<BR>Thus the process has been paused.<BR>To resume, please click <A HREF="javascript:edit(\''+file+'\',true)">here</A>.<BR>To cancel, please click <A HREF="javascript:browseTo();">here</A>.<BR></CENTER>');
					}
				}
				else {writeDiv('list','<CENTER><IMG src="./themes.cgi?icon=loading" border=0><BR><BR>The file you are attempting to edit is taking a long time to load. The connection may have died, or the server simply forgot our request.<BR>To try again, please click <A HREF="javascript:edit(\''+file+'\',true)">here</A>.<BR>To cancel, please click <A HREF="javascript:browseTo();">here</A>.<BR></CENTER>');}
			}
		} catch(e) {}		//ie cannot get enough data fast enough, so we fall back on this pretty often... thus don't do anything!!
	}
	xmlhttp.send(null);
}

/*This function downloads data and calls a specified function to deal with it...!*/
function receive(what,function_callback) {
	currentop = 'Curent Operation:\nDownloading data for internal use...';
	var xmlhttp = getHttpObj();		//get a new AJAX object per call !!
	
	if(!xmlhttp) {alert('invalid xmlhttp object!! Are you sure your browser supports it?');return;}
	changeDiv('bgactivity','visible');
	
	var fs_time = (new Date()).getTime();
	var send = "./action.cgi?time="+fs_time+'&action='+what;
	
	xmlhttp.open("GET",send,true);
	xmlhttp.setRequestHeader("charset", "ISO-8859-1");
	xmlhttp.onreadystatechange=function() {
		try {
			if (xmlhttp.readyState==4) {
				if(xmlhttp.status == 200) {
					var t=xmlhttp.responseText;
					changeDiv('bgactivity','hidden');
					if(t) {
						if(!t.match(/<ok>/gi)) {
							showError('Failed to complete the requested action: permission denied.<BR><SMALL><PRE>'+t+'</PRE></SMALL>');
						}
						else {function_callback(t);}
					}
				}
				else {changeDiv('bgactivity','hidden');showError('Unable to get the requested data!');}
			}
		} catch(e) {changeDiv('bgactivity','hidden');showError('Unable to get the requested data!');}
	}
	xmlhttp.send(null);
}

/*This function simulates the old fetch function...*/
function fetch(where,what) {
	writeDiv(where,'Loading...');
	return receive(what,function(r) {writeDiv(where,r);});
}


/*This function downloads the file preview from the server!*/
function fetch_preview(file) {
	currentop = 'Curent Operation:\nDownloading file preview...';
	var xmlhttp = getHttpObj();		//get a new AJAX object per call !!
	
	if(!xmlhttp) {alert('invalid xmlhttp object!! Are you sure your browser supports it?');return;}
	changeDiv('bgactivity','visible');
	
	var fs_time = (new Date()).getTime();
	var send = "./action.cgi?time="+fs_time+'&action=getpreview&param='+file;
	
	xmlhttp.open("GET",send,true);
	xmlhttp.setRequestHeader("charset", "ISO-8859-1");
	xmlhttp.onreadystatechange=function() {
		try {
			if (xmlhttp.readyState==4) {
				if(xmlhttp.status == 200) {
					var t=xmlhttp.responseText;
					changeDiv('bgactivity','hidden');
					if(t) {writeDiv('preview',t);}
				}
				else {changeDiv('bgactivity','hidden');writeDiv('preview','Connection to server timed out...');}
			}
		} catch(e) {writeDiv('preview','Connection to server timed out...');changeDiv('bgactivity','hidden');}
	}
	xmlhttp.send(null);
}







