/********************************************************************************************
	Secondary Javascript file for Wefis 1.4
	Written in April 2006
	This file is an integral part of Wefis, and code herein is licensed under GPL.
	If you use code in these files, please keep the following lines in the code:
	
	Programmed by Franois Botman for Wefis (http://wefis.sf.net).
	If you find bugs, please report them here: franchie@users.sourceforge.net
***********************************************************************************************/

/**********************************************************************************************
	File.js; contains all the functions to manage fileviews, directory browsing, previews, icons, chmod, etc...
	It obtains its data directly from the central divs, and is not responsible for refreshing it...
	Dependancies; data.js, main.js
**********************************************************************************************/

/*------------------------------------------------------------------------------------------------------------------------------------------
	Data format in div 'raw';
	[filename+path] | [extension/format] | [created date] | [last modified date] | [last accessed date] [chmod permissions] | [filesize] \n
	1) /root/file/name
	2) zip, txt, or 'directory'
	3+4+5) 12/133/67 10:76
	6) rwrwwr--r (755)
	7) filesize
-------------------------------------------------------------------------------------------------------------------------------------------*/
//TRY escape!!!

var prevselect=0;
var displayMode=0;
var hideLeftBar=1;
var displayHide='';


/*This function cleans the path to enable going up/down (ie: gets rid of ../ 's whilst not allowing to move higher than /)...*/
/*function cleanPath(path) {
	//collapse expanded tree:
	path = path.replace(/[^\/]*\/\.\./g,'');
	// get rid of any spurious (dangerous) '..'s:
	path = path.replace(/\.\./g,'');
	// remove multiple '/'s left over:
	path = path.replace(/\/\//g,'/');
	return path;		//for now, just return path ;-)
}*/
function cleanPath(path) {
	path = path.replace(/\/\.\//g,'/');			// /./ are redundant!
	path = path.replace(/\.\.\//g,'@/');		//replace troublesome ../ by something else...
	while(path.match(/@\//g)) {					//while there is something to replace...
		path = path.replace(/@\//,'../');			//change the first @/ back
		path = path.replace(/[^\/]*\/\.\./,'');		//replace it...
		path = path.replace(/\.\./g,'');			//remove any remaining .. or //
		path = path.replace(/\/\//g,'/');
	}
	// get rid of any spurious (dangerous) '..'s:
	path = path.replace(/\.\./g,'');
	// remove multiple '/'s left over:
	path = path.replace(/\/\//g,'/');
	return path;		//for now, just return path ;-)
}

/*This function updates the path in all necessary places...*/
function UpdatePath(path) {
	setData('location',path);
	var html='<A HREF="#" name="loc" id="loc" onMouseOver="if(!document.getElementById(\'goto\')) writeGoto();"><SMALL><B>'+path+'</B> <IMG src="./themes.cgi?icon=pulldown" border=0 align="top"> </A></SMALL>';
	writeDiv('locbar',html);
	
	html='';	
	if(showFavIcon(path)) html = '<A HREF="javascript:addToFav();"><IMG SRC="./themes.cgi?icon=fav" BORDER=0 WIDTH="25" HEIGHT="25"></A>';
	writeDiv('favbar',html+'<BR><A HREF="javascript:show_search();"><IMG SRC="./themes.cgi?icon=search" WIDTH="25" BORDER=0 HEIGHT="25"></A>');
	
	if(path=='/') {
		if(getOption('tool_labels')) writeDiv('upbutton','<IMG SRC="./themes.cgi?icon=refresh" BORDER=0 /><BR>Refresh');
		else writeDiv('upbutton','<IMG SRC="./themes.cgi?icon=refresh" BORDER=0 />');		//only useful if we change image...
	}
	else {if(getOption('tool_labels')) writeDiv('upbutton','<IMG SRC="./themes.cgi?icon=up" BORDER=0 /><BR>Up');else writeDiv('upbutton','<IMG SRC="./themes.cgi?icon=up" BORDER=0 />');}
}

/*This function switches mode multimode<->normal */
function modeSwitch()
{
	if(displayMode==0) {displayMode=1;if(getOption('tool_labels')) writeDiv('multibutton','<IMG SRC="./themes.cgi?icon=multi" BORDER=0 ><BR>NormalMode');else writeDiv('multibutton','<IMG SRC="./themes.cgi?icon=multi" BORDER=0 >');}
	else {displayMode=0;if(getOption('tool_labels')) writeDiv('multibutton','<IMG SRC="./themes.cgi?icon=multi" BORDER=0 ><BR>MultiMode');else writeDiv('multibutton','<IMG SRC="./themes.cgi?icon=multi" BORDER=0 >');}
	browseTo();
}

/*This functio shortens the string if it is too long by replacing it with ...*/
function shortenStr(str,chars){
	if(!chars) var chars=20;
	if(str.length<chars) return str;
	var rep='';
	for(var i=0;i<(chars-3);i++) rep+=str.charAt(i);
	rep+='...';
	return rep;
}

/* This function escapes strings to make them regexp-compatible...*/
function makeRegExp(str)
{
	var copy = str;
	copy = copy.replace(/\[/,'\\[');
	copy = copy.replace(/\(/,'\\(');
	copy = copy.replace(/\]/,'\\]');
	copy = copy.replace(/\)/,'\\)');
	copy = copy.replace(/\\/,'\\');
	copy = copy.replace(/\'/,'\\\'');
	copy = copy.replace(/\"/,'\\"');
	return copy;
}

/*This function returns true if the item is located in that directory...*/
function isCorrectFolder(what,dir) {
	var cp = what;
	var reg = new RegExp('^'+makeRegExp(dir));		//Removed ,"i" since we do not want to ignore case!!!
	
	if(!cp || !cp.match(reg)) return false;	//wrong branch!!
	if(displayMode==2) return true;			//ok... this file is in here or below!
	cp = cp.replace(reg,'');	//gets rid of the path...
	if(!cp) return false;
	
	b = cp.split('/');	//split at / and cound non-null bits...
	if(b[1] || !b[0]) return false;
	return true;
}

function getFileName(n) {
	var p = n.split('/');
	if(p[p.length-1]) return p[p.length-1];
	return p[p.length-2];	//directories have a troublesome ending /
}
/*
function getImg(n) {
	//chek to see if a special icon is applicable...
	n=n.replace(/\./gi,'');			//get rid of any dots!!
	/ *var exts = getData('exts');
	var reg = new RegExp(n+'\\|');
	if(exts.match(reg)) return './img/icons/'+n+'.png';			//we have a special con for this!!
	if(n.match(/(tar|tar\.gz|gz|zip)$/gi)) return './img/icons/zip.png';
	if(n.match(/(jpg|gif|png|bmp|tiff)$/gi)) return './img/icons/img.png';
	if(n.match(/(txt|html|shtml|htm|inf|dat|pl|cgi|bak|tex|css)$/gi)) return './img/icons/txt.png';
	if(n.match(/(wav|mid|mp2|mp3|ogg|mus|wma)$/gi)) return './img/icons/wav.png';
	return './img/icons/unknown.png';* /
	return './themes.cgi?extension='+n;
}*/


/*This function allows the fileview to be created for a particular directory...*/
function browseTo(path,select) {
	hideLeftBar=1;
	if(!path) path=getData('location');					//ensure that the path is not null...
	if(path=='../') path = getData('location')+'../';	//easier for the 'go up' button...
	path = cleanPath(path);								//get rid of that ../
	
	if(path == "Refresh") {updateRawData(true,true);return;}	//if user requests a refresh, then do it!!
	UpdatePath(path);
	clearLeft();
	
	if(displayMode!=0) {multiMode(path,select);return;}
	
	var current = getData('location');
	if(path!='/') show_finfo(path);
	else displayHide='';
	var data = getData('raw');		//get the raw directory information...
	var finfo = data.split('\n');	//split each newline!
	html='<TABLE width=600><TR>';
	var trow=0;
	
	for(var i=0;i<finfo.length;i++) {
		bits = finfo[i].split('|');
		if(bits[0]) {	//file path and extension...
			if(isCorrectFolder(bits[0],current)) {
				var fname = getFileName(bits[0]);
				if(bits[1]=='directory') {			//do the special directory thingy...
					bits[0] = bits[0].replace(/'/,'\\\'');
					var fnamp = fname.replace(/'/,'\\\'');
					html+='<TD class="dir" onclick="prevselect=0;browseTo(\''+bits[0]+'\');" title="'+fname+'"><CENTER><A ';
					// HREF=\"#\"
					html+='onmouseover="writeDiv(\'status\',\'Click to enter '+fnamp+'\');" onmouseout="writeDiv(\'status\',idletext);">';
					html+='<IMG Border=0 SRC="./themes.cgi?icon=folder" alt="'+fname+'"><BR>'+fname+'</A></CENTER></TD>';
				}
				else {
					if(select==fname) html+='<TD class="selectedfile" name="selecteditem" id="selecteditem" ';
					else html+='<TD class="file"';
					bits[0] = bits[0].replace(/'/,'\\\'');
					var fnamp = fname.replace(/'/,'\\\'');
					html+='onclick="select(this);show_finfo(\''+bits[0]+'\');" title="'+fname+'"><CENTER><A  onmouseover="writeDiv(\'status\',\'Click to view file '+fnamp+'.\');" ';
					//  HREF="#"
					html+='onmouseout="writeDiv(\'status\',idletext);"><IMG Border=0 SRC="'+getImg(bits[1])+'" alt="'+fnamp+'"><BR>';
					fname = shortenStr(fname,15);
					html+=fname+'</A></CENTER></TD>';
				}
				trow++;
				if(trow>=5) {html+='</TR><TR>';trow=0;}
			}
		}
	}
	if(html=='<TABLE width=600><TR>') {
		html+='<TD>No files or folders in here:<br>';
		html+='<A HREF="#" onclick="deleteItem(\''+path+'\',true);">Delete This Directory</A> | ';
		html+='<A HREF="#" onclick="newFileForm();">Create a File</A> | ';
		html+='<A HREF="#" onclick="uploadForm();">Upload a File</A></TD>';
	}
	html+='</TR></TABLE>';
	writeDiv('list',html);
	if(select) {show_finfo(path+select);prevselect = document.getElementById('selecteditem');}
}

/*THis function does all the multimode stuff...*/
function multiMode(path,select) {
	var html='<H1>MultiMode</H1>';
	html+='<TABLE width=600><TR><TD>Welcome to multi-mode. In this view, you can select many files to do the same operation to. This allows you to delete many files at once, for example.</TD></TR></TABLE><br>';
	html+='<CENTER><label for="multbut" onmouseover="writeDiv(\'status\',\'Starts recursive MultiMode, for multiple-file operations on all files within in this directory\');" onmouseout="writeDiv(\'status\',idletext);"><INPUT TYPE=checkbox name="multbut" id="multbut"';
	if(displayMode==2) html+='onclick="displayMode=1;browseTo();" CHECKED';
	else html+=' onclick="displayMode=2;browseTo();"';
	html+='>Recursive Mode?</LABEL></CENTER><A name="labeltrue"></A><BR>';
	
	//selection buttons...
	html+=multimode_selectbuttons(true);
	
	html+='<FORM name="multiform" id="multiform" action="javascript:multimode_submit(this);"><TABLE border=1>';
	
	var current = getData('location');
	var data = getData('raw');		//get the raw directory information...
	var finfo = data.split('\n');	//split each newline!
	var reg = new RegExp(current,"i");
	
	for(var i=0;i<finfo.length;i++) {
		bits = finfo[i].split('|');
		if(bits[0] && bits[1]) {	//file path and extension...
			if(isCorrectFolder(bits[0],current)) {
				var fname = bits[0].replace(reg,'');
				if(bits[1]!='directory') {			//do the special directory thingy...
					html+='<TR><TD><LABEL for="'+fname+'"><INPUT TYPE=checkbox name="cb" id="'+fname+'" value="'+current+fname+'"';
					if(select==fname) html+=' CHECKED';
					html+='>'+fname+'</LABEL></TD></TR>';
				}
			}
		}
	}

	html+='</TABLE><A NAME="tbottom"></A>';
	html+=multimode_selectbuttons();
	html+='<BR><BR><select name="multi_action" id="multi_action"><option value="download">download</option><option value="delete">delete</option><option value="chmod">chmod</option><option value="copy">copy to</option><option value="move">move to</option>';
	
	var p = getData('plugins');
	if(p && getOption('plugin')) {
		var plugs = p.split('|');
		for(var i=0;i<plugs.length;i++) {
			var b = plugs[i].split(',');
			if(b[0] && b[1]) {html+='<option value="'+b[1]+'" SELECTED>'+b[0]+'</option>';}
		}
	}
	
	html+='</select><input type=text name="param1" id="param1" value="" size=6>';
	html+='<input type=submit value="perform"><input type=button value="Close" onclick="modeSwitch();browseTo();"></FORM>';
	writeDiv('list',html);
}

/*This function submits the multimode data..*/
function multimode_submit(form) {
	var action = getData('multi_action');
	var param  = getData('param1');
	if(!document.forms['multiform']) return;
    var objCheckBoxes = document.forms['multiform'].elements['cb'];
    if(!objCheckBoxes) {return;}
	var values='';
	var current = getData('location');
	
	for(var i=0;i<objCheckBoxes.length;i++) if(objCheckBoxes[i].checked) values+=objCheckBoxes[i].value+'|';
	
	if(action == 'delete') {
		if(guestUser()) return;
		if(!confirm('***** WARNING *****\nYou are about to delete several files!\nAre you sure you wish to do this?')) return;
		checkBoxData('delete',values);
	}
	else if(action == 'chmod') {
		if(guestUser()) return;
		if(!param) {alert('CHMOD requires a value to chmod to...');return;}
		checkBoxData('chmod',values,param);
	}
	else if(action == 'copy') {
		if(guestUser()) return;
		if(!param) {alert('COPY requires a directory name to copy to...');return;}
		var p = current+'/'+param;
		p = p.replace(/\/\//g,'/');
		checkBoxData('copy',values,cleanPath(p));
	}
	else if(action == 'move') {
		if(guestUser()) return;
		if(!param) {alert('MOVE requires a directory to move to...');return;}
		var p = current+'/'+param;
		p = p.replace(/\/\//g,'/');
		checkBoxData('move',values,cleanPath(p));
	}
	else if(action == 'download') {
		checkBoxData('download',values,current);
	}
	else {		//is a plugin...
		checkBoxData(action,values,param);
	}
}

/*This displays the selection buttons...*/
function multimode_selectbuttons(top) {
	var txt='(select <a href="#label'+top+'" onclick="multimode_select(\'all\');">all </a> | <a href="#label'+top+'" onclick="multimode_select(\'none\');"> none </a>';
	if(top) txt+=' | <a href="#label'+top+'" onclick="multimode_select(\'some\');"> some </a> | <a href="#tbottom"> goto bottom </a>)<DIV id="select_some" name="select_some"></DIV>';
	else txt+=')';
	return txt;
}

function multimode_select(what) {
	if(!document.forms['multiform']) return;
    var objCheckBoxes = document.forms['multiform'].elements['cb'];
    if(!objCheckBoxes) {return;}	//there is nothing to select!
	var checked=0;
	if(what=='all') for(var i=0;i<objCheckBoxes.length;i++) objCheckBoxes[i].checked = true;
	else if(what=='none') for(var i=0;i<objCheckBoxes.length;i++) objCheckBoxes[i].checked = false;
	else if(what=='some') {
		var h='[';
		h+='<a href="#labeltrue" onclick="multimode_select(\'images\');"> images </a> ';
		var done='|';
		var cnt=0;
		for(var i=0;i<objCheckBoxes.length;i++) {
			var t = objCheckBoxes[i].value;
			var s = t.split('.');
			// try s[s.length-1] instead of s[1]...
			if(s[1]) {		// s[1] contains the extension...
				var reg = new RegExp('\\|'+s[1]+'\\|','gi');
				if(!done.match(reg)) {done+=s[1]+'|';cnt++;h+=' | <a href="#labeltrue" onclick="multimode_select(\''+s[1]+'\');">.'+s[1]+'</a> ';}
			}
			if(cnt>10) break;		//only do a few!!
		}
		h+=']<DIV id="select_howmany" name="select_howmany"></DIV>';
		writeDiv('select_some',h);
	}
	else if(what=='images') {		//image filter ;-)
		for(var i=0;i<objCheckBoxes.length;i++) {
			var t = objCheckBoxes[i].value;
			var s = t.split('.');
			if(s[1] && s[1].match(/(jpg|jpeg|gif|png|bmp|tiff|ico)$/gi)) objCheckBoxes[i].checked = true;
			if(objCheckBoxes[i].checked) checked++;
			//else objCheckBoxes[i].checked = false;
		}
	}
	else {		//custom filter ;-)
		for(var i=0;i<objCheckBoxes.length;i++) {
			var t = objCheckBoxes[i].value;
			var s = t.split('.');
			if(s[1] && (s[1].toLowerCase()==what.toLowerCase())) objCheckBoxes[i].checked = true;
			if(objCheckBoxes[i].checked) checked++;
		}
	}
	if(checked) writeDiv('select_howmany','<I>---> '+checked+' item(s) checked</I>');
}

/*The following function is called when the window is resized...*/
function file_info_resize(r) {
	//var w = (window.innerWidth) ? (window.innerWidth) : (document.body.clientWidth);
	if(window.innerWidth)  var w = window.innerWidth;
	else if(window.clientWidth) var w = window.clientWidth;
	else if(document.body.clientWidth) var w = document.body.clientWidth;
	else {hideLeftBar=0;var w = 0;}		//browser does not support anything!! stop anything else happening!
	
	if(!document.getElementById('fileinfo') || !document.getElementById('preview')) return;	//still loading...
	if(hideLeftBar && (w<880)) {
		if(displayHide) writeDiv('fileinfo','<A HREF="javascript:hideLeftBar=0;show_finfo(\''+displayHide+'\');">show >></A>');
		else writeDiv('fileinfo',' ');
		writeDiv('preview',' ');
		hideLeftBar=2;
	}
	else if((hideLeftBar==2) && (w>880)) {
		if(displayHide) show_finfo(displayHide);
		hideLeftBar=1;
	}
	return true;
}
window.onresize = file_info_resize;

/*The following function does a file info in the sidebar..*/
function show_finfo(file) {
	if(window.innerWidth)  var w = window.innerWidth;
	else if(window.clientWidth) var w = window.clientWidth;
	else if(document.body.clientWidth) var w = document.body.clientWidth;
	else {hideLeftBar=0;var w=0;}		//browser does not support anything!! stop anything else happening!
	displayHide = file;
	if((hideLeftBar) && (w<880)) return file_info_resize();		//too small to draw!!
	
	var html='';
	var q = getData('raw').split('\n');
	var i=0;
	for(i=0;i<q.length;i++) if(q[i].split('|')[0] == file) break;
	if(!q[i]) return;
	var info = q[i].split('|');
	
	html+='<H1>'+shortenStr(getFileName(file),30)+'</H1>';
	
	if(info[1]!='directory') {
		html+='<a href="'+getData('root_url')+file+'" target="_new" onmouseover="writeDiv(\'status\',\'Opens the file to be viewed in a new Browser Window or Tab\');" onmouseout="writeDiv(\'status\',idletext);">';
		if(file.match(/\.(shtml|html|htm|xml|cgi|pl|php|txt|c|h|tex|java|cpp|jpg|bmp|png|gif|jpeg)$/gi)) html+= '(open in new window)</a><br><br>';
		else html+='(download file)</a><br><br>';
	}
	
	if(info[1]!='directory') {
		var value = info[6]/(1024*1024);
		if(info[6]>(1024*1024)) html+='File Size: '+value.toFixed(2)+'Mb';
		else if(info[6]>1024) html+='File Size: '+parseInt(info[6]/1024)+'kb';
		else html+='File Size: <1 kb';
	}
	
	html+='<BR>Permissions: '+info[5]+'<BR>';
	html+='Created: '+info[2]+'<BR>';
	html+='Modified: '+info[3]+'<BR>';
	html+='Accessed: '+info[4]+'<BR><BR>';
	
	html+='<form method="get" name="f1">';
	if(info[1]!='directory') {
		var fnamp = file.replace(/'/,'\\\'');
		if(info[1].match(/(zip|tar|tar\.gz)$/)) html+='<b><a href="#" onclick="if(confirm(\'You are about to extract files from this archive. Some existing files may be overwritten if they are already contained within the archive... Are you sure you wish to continue?...\')) {sendData(\'extract_file\',\''+fnamp+'\',\'Archive Deflated!\');}" onmouseover="writeDiv(\'status\',\'Decompresses this archive to the current directory.\');" onmouseout="writeDiv(\'status\',idletext);">Deflate archive</a></b> | ';
		html+='<A HREF="#" onClick="edit(\''+fnamp+'\');" onmouseover="writeDiv(\'status\',\'Edit this file.\');" onmouseout="writeDiv(\'status\',idletext);">Edit</A> | <A HREF="#" value="delete" onClick="deleteItem(\''+fnamp+'\');" onmouseover="writeDiv(\'status\',\'** Deletes this file **\');" onmouseout="writeDiv(\'status\',idletext);">Delete</A> ';
		html+='<BR><input type=text name="fname" id="fname" value="'+getFileName(file)+'" size=6><INPUT TYPE=button value="Rename" onClick="renameItem(\''+fnamp+'\',getRelativeAbsolute(\'fname\'));">';
		html+='<BR><input type=text name="cpname" id="cpname" value="'+getFileName(file)+'" size=6><INPUT TYPE=button value="Copy" onClick="copyItem(\''+fnamp+'\',getRelativeAbsolute(\'cpname\'));">';
		html+='<BR><input type=text name="chmname" id="chmname" value="755" size=6><INPUT TYPE=button value="Chmod" onClick="chmodItem(\''+fnamp+'\',ElementValue(\'chmname\'));">';
	}
	else {
		var fnamp = file.replace(/'/,'\\\'');
		html+='<BR><input type=text name="fname" id="fname" value="'+getFileName(file)+'" size=6><INPUT TYPE=button value="Rename" onClick="renameItem(\''+fnamp+'\',getRelativeAbsoluteFolder(\'fname\'),true);">';
		html+='<BR><input type=text name="cpname" id="cpname" value="'+getFileName(file)+'" size=6><INPUT TYPE=button value="Copy" onClick="copyItem(\''+fnamp+'\',getRelativeAbsoluteFolder(\'cpname\'),true);">';
		html+='<BR><input type=text name="chmname" id="chmname" value="755" size=6><INPUT TYPE=button value="Chmod" onClick="chmodItem(\''+fnamp+'\',ElementValue(\'chmname\'),true);">';
	}
	if(info[1]=='directory') html+='<BR><INPUT TYPE=button value="Delete" onClick="deleteItem(\''+fnamp+'\',true);">';
	html+='</FORM><BR>';
	
	writeDiv('fileinfo',html);
	if(info[1]!='directory') writeDiv('preview','<A HREF="javascript:fetch_preview(\''+fnamp+'\');">Generate Preview</A>');
}


/*Checks whether the file or directory already exists...*/
function fileExists(f) {
	var q = getData('raw').split('\n');
	for(var i=0;i<q.length;i++) if(q[i].split('|')[0] == f) return true;
	return false;
}

/* This function decides whether or not the folder is a relative, or an absolute one... */
function getRelativeAbsoluteFolder(item) {
	var name = ElementValue(item);
	if(name.match(/^\//gi)) {	//beings with a slash, probably an absolute path...
		if(confirm('The filename you have entered appears to be an absolute path (location from root /), and not a relative path.\nAm I correct?')) return name;
	}
	if(!name.match(/^\.\//gi)) return cleanPath(getData('location')+'../'+name);
	else return cleanPath(getData('location')+name);
}

/* This function decides whether or not the file is a relative path, or an absolute one...  (from a div)*/
function getRelativeAbsolute(item) {
	return getRelativeAbsoluteName(ElementValue(item));
}
/* This function decides whether or not the file is a relative path, or an absolute one... (from a path)*/
function getRelativeAbsoluteName(name) {
	if(name.match(/^\//gi)) return cleanPath(name);		//used to be confirmable, but was mostly correct anyway...
	return cleanPath(getData('location')+name);
}

/* This function creates intermediate directories when copying/moving to a directory that does not yet exist... */
function createInterDirs(name) {
	var fname = '';
	var bits = name.split('/');
	for(var i=0;i<(bits.length-1);i++) {
		fname+=bits[i];
		fname=cleanPath(fname);
		if(!fname.match(/\/$/)) fname+='/';
		if(fname && !fileExists(fname)) {
			setData('raw',getData('raw')+fname+'|directory|today|today|today|rwxrwxrwx|0\n');
			if(getOption('index')) create_file(fname+'/index.html','shuttup');
		}
	}
}

/* The following function creates a new (empty) file... */
function create_file(name,shutup) {
	clearLeft();
	if(guestUser()) return;
	var fname = getRelativeAbsoluteName(name);
	fname = cleanPath(fname);
	if(fileExists(fname)) {if(!shutup) alert('ERROR: The file specified already exists! Please choose another name!');return;}
	fname.replace(/\/$/,'');
	var ext = fname.split('.')[1];
	if(!getData('raw').match(/\n$/)) setData('raw',getData('raw')+'\n');
	setData('raw',getData('raw')+fname+'|'+ext+'|today|today|today|rwxrwxrwx|0\n');
	createInterDirs(fname);
	if(!shutup) {sendData('create_file',fname,'File Created');browseTo('',getFileName(fname));}
	else sendData('create_file',fname);
}

/* The following function creates a new (empty) directory... */
function create_dir(name) {
	clearLeft();
	if(guestUser()) return;
	var fname = getRelativeAbsoluteName(name);
	if(!fname.match(/\/$/)) fname+='/';
	fname = cleanPath(fname);
	if(fileExists(fname)) {alert('ERROR: The folder specified already exists! Please choose another name!');return;}
	if(!getData('raw').match(/\n$/)) setData('raw',getData('raw')+'\n');
	setData('raw',getData('raw')+fname+'|directory|today|today|today|rwxr-xr-x|0\n');
	
	sendData('create_dir',fname,'Directory Created');
	//if enabled, create the index file... 
	if(!name.match(/\/$/)) name+='/';
	if(getOption('index')) create_file(name+'/index.html','shuttup');
	createInterDirs(fname);
	browseTo(fname);
}

/* THis function renames a given file/directory...*/
function renameItem(fullname,to,isdir) {
	if(guestUser()) return;
	if(!fullname || !to) return;
	to = cleanPath(to);
	var raw = getData('raw');
	if(isdir && !to.match(/\/$/)) to+='/';					//add trailing slash!!
	if(isdir && !fullname.match(/\/$/)) fullname+='/';		//add trailing slash!!
	if(fileExists(to)) {alert('ERROR: The file specified already exists! Please choose another name!');return;}
	
	if(fullname.match(/\/$/)) {
		var reg = new RegExp(fullname,"gi");		//what if its a directory?
		raw = raw.replace(reg,to);
	}
	else {
		var reg = new RegExp(fullname+'\\|',"gi");						//otherwise just rename that file...
		raw = raw.replace(reg,to+'|');
	}
	
	setData('raw',raw);		//replace the data...
	createInterDirs(to);
	
	sendData('rename',fullname+'&to='+to,'Item Renamed');
	browseTo(to.replace(/[^\/]*$/g,''),getFileName(to));
}

/* THis function copies a given file/directory...*/
function copyItem(fullname,to,isdir) {
	if(guestUser()) return;
	to = cleanPath(to);
	if(!fullname || !to) return;
	if(!getData('raw').match(/\n$/)) setData('raw',getData('raw')+'\n');
	var raw = getData('raw');
	if(isdir && !to.match(/\/$/)) to+='/';		//add trailing slash!!
	if(fileExists(to)) {alert('ERROR: The file specified already exists! Please choose another name!');return;}
	
	//Old code, invalid copy on some concurrent filenames!
	/*var reg = new RegExp(fullname,"gi");
	//raw = raw.replace(reg,to);
	var b = raw.split('\n');
	for(var i=0;i<b.length;i++) {
		if(b[i].match(reg)) raw+=b[i].replace(reg,to)+'\n';
	}*/
	
	var reg = new RegExp(fullname,"gi");
	var b = raw.split('\n');
	for(var i=0;i<b.length;i++) {
		//if(b[i].split('|')[0] == fullname) raw+=b[i].replace(reg,to)+'\n';
		if(b[i].split('|')[0].match(reg)) raw+=b[i].replace(reg,to)+'\n';
	}
	setData('raw',raw);		//replace the data...
	
	createInterDirs(to);
	
	sendData('copy',fullname+'&to='+to,'Item Copied');	
	browseTo(to.replace(/[^\/]*$/g,''),getFileName(to));
}

/* THis function chmods a given file/directory...*/
function chmodItem(fullname,value,isdir) {
	if(guestUser()) return;
	if(!fullname || !value) return;
	var raw = getData('raw');
	
	var b = raw.split('\n');
	raw='';
	for(var i=0;i<b.length;i++) {
		var p = b[i].split('|');
		if(p[0] == fullname) raw+=p[0]+'|'+p[1]+'|'+p[2]+'|'+p[3]+'|'+p[4]+'|[changed to '+value+']|'+p[6]+'\n';
		else raw+=b[i]+'\n';
	}
	setData('raw',raw);		//replace the data...
	
	sendData('chmod',fullname+'&to='+value,'Permissions Changed');	
	browseTo('',getFileName(fullname));
}

/* THis function chmods a given file/directory...*/
function deleteItem(fullname,isdir) {
	if(guestUser()) return;
	if(!fullname) return;
	var raw = getData('raw');
	
	var b = raw.split('\n');
	var reg = new RegExp(fullname,"gi");
	raw='';
	var cnt=0;
	
	if(isdir) {
		for(var i=0;i<b.length;i++) if(b[i].match(reg)) cnt++;
		if(cnt>1) if(!confirm('Caution: This directory is not empty; it still contains '+(cnt-1)+' files or folders...\nAre you sure you wish to continue this operation?')) return;
		for(var i=0;i<b.length;i++) if(!b[i].match(reg)) raw+=b[i]+'\n';
	}
	else {
		if(!confirm('*** Caution: ***\nAre you sure you wish to delete this file?')) return;
		for(var i=0;i<b.length;i++) {
			var p = b[i].split('|');
			if(p[0] != fullname) raw+=b[i]+'\n';
		}
	}
	setData('raw',raw);		//replace the data...
	
	sendData('delete',fullname,'Item Deleted');	
	if(isdir) browseTo('../');		//go up, since the file does not exist...
	else browseTo();
}
/* This function selects (highlights) files in the main file view...*/
function select(a) {
	/*if(prevselect && prevselect.style) {prevselect.style.backgroundColor = "#FFFFFF";}
	a.style.backgroundColor = "#F5F5F5";*/
	if(prevselect && prevselect.style) prevselect.className="file";
	a.className="selectedFile";
	prevselect = a;
}






	