/********************************************************************************************
	Main Javascript file for Wefis 1.4
	Written in April 2006
	This file is an integral part of Wefis, and code herein is licensed under GPL.
	If you use code in these files, please keep the following lines in the code:
	
	Programmed by Franois Botman from Wefis (http://wefis.sf.net).
	If you find bugs, please report them here: franchie@users.sourceforge.net
***********************************************************************************************/

/**********************************************************************************************
	Mais.js; contains the main (non-specialised) functions which will be used in Wefis.
	That includes key-callback functions and the data updating...
	It also contains the busy functions, and is in charge of the graphical interface...
	Dependancies; ajax.js
**********************************************************************************************/


/*This function catches button presses...*/
function changeKey(event){
	if(!event.ctrlKey) {
		switch(event.keyCode) {
		case 116:							//116 = ascii for F5. On F5, refresh wefis!
			updateRawData(true,true);
			break;
		// IS ESCAPE -> return to default view really a desireable behaviour? I do not believe so, 'cos what happens to unsaved data in an edit form?
		/*case 27:							//27 = ESCAPE, go back to the folder view!
			browseTo();
			break;*/
		case 9:								//9 = tab. If in text-editing mode, then do a tab!!!
			if(document.getElementById('content')) {			//editing in small window..
				insertAtCursor(document.getElementById('content'),'\t');
			}
			else if(document.getElementById('content_full')) {	//editing in fullscreen view...
				insertAtCursor(document.getElementById('content_full'),'\t');
			}
			else return true;
			break;
		default:
			//if(!event.ctrlKey) {alert('Key pressed with ascii code: '+event.keyCode);return true;}		//debug!!
			return true;
		}
	}
	else {
		var key = String.fromCharCode(event.which || event.charCode || event.keyCode).toLowerCase();
		switch(key) {
			case 'f':
				if(!document.getElementById('list')) return true;	//we are not in the right window!!! ouch, stop here.
				show_search();
				break;
			case 's':
				if(document.getElementById('d8er')) {		//fullscreen window
					writeDiv('send','<CENTER><B><BR>Please Wait: Saving File');
					saveFile('content_full',getData('file'),-1);
				}
				else if(document.getElementById('content')){					//normal window...
					saveFile('content',getData('file'),0);
				}
				else return true;
				break;
			default:
				return true;
		}
	}
	if (event.preventDefault) {
		event.preventDefault();
		event.stopPropagation();
	}
	else {
		event.returnValue = false;
		event.cancelBubble = true;
	}
	return false;
}
//document.onkeydown=function(e){changeKey((e||window.event).keyCode, 1);}
//document.onkeyup=function(e){changeKey((e||window.event).keyCode, 0);}
if (document.addEventListener) document.addEventListener("keypress", changeKey,true);
else if (document.attachEvent) document.attachEvent("onkeydown", changeKey);//function(evt) {changeKey(evt)});

/*Catch any leftover errors; eg, unsupported browser,...*/
window.onerror=function(r){
	alert('An error occurred during the execution of this command. This error may impact future functionning of wefis, so it would be safest to reload the page.\nPlease be aware that wefis is only supported under modern browsers such as Firefox and IE.\n\nError: '+r+'\nIf this appears serious, please report it at wefis.sf.net');
	return true;
}




//Code modified from the phpMyAdmin project, licenced under GPL. Thanks for the inspiration!
/*function insertAtCursor(myField, myValue) {
	if(document.selection) {		//IE support
		myField.focus();
		sel = document.selection.createRange();
		sel.text = myValue;
	}
	//MOZILLA/NETSCAPE support
	else if(myField.selectionStart || myField.selectionStart == '0') {
		myField.value = myField.value.substring(0, myField.selectionStart) + myValue + myField.value.substring(myField.selectionEnd, myField.value.length);
	}
	else myField.value += myValue;
}*/
function insertAtCursor(myField, myValue) {
	//IE support
	if (document.selection) {
		var temp;
		myField.focus();
		sel = document.selection.createRange();
		temp = sel.text.lenght;
		sel.text = myValue;
		if (myValue.length == 0) {
			sel.moveStart('character', myValue.length);
			sel.moveEnd('character', myValue.length);
		} else {
			sel.moveStart('character', -myValue.length + temp);
		}
		sel.select();
	}
	//MOZILLA/NETSCAPE support
	else if (myField.selectionStart || myField.selectionStart == '0') {
		var startPos = myField.selectionStart;
		var endPos = myField.selectionEnd;
		myField.value = myField.value.substring(0, startPos) + myValue + myField.value.substring(endPos, myField.value.length);
		myField.selectionStart = startPos + myValue.length;
		myField.selectionEnd = startPos + myValue.length;
	} else {
		myField.value += myValue;
	}
}

/*This function returns the value of data in the named form...*/
function ElementValue(name) {
	if(document.getElementById) return document.getElementById(name).value;
	else if(document.name) return document.name.value;
	else if(document.all.name) return document.all.name.value;
}

/*This function writes data to a given div*/
function writeDiv(id,txt) {
	if (document.layers && document.layers[id]) {
		document.layers[id].document.open();
		document.layers[id].document.write(txt);
		document.layers[id].document.close();
		document.layers[id].visibility = 'show';
	}
	else if(document.getElementById(id)) {
		document.getElementById(id).innerHTML = txt;
		document.getElementById(id).style.visibility = 'visible';
	}
	if(document.getElementById(id).style.display=="none") document.getElementById(id).style.display="block";
}

/*This function show or hides named elements...*/
function changeDiv(a,divstatus) {
	if(document.getElementById(a)) {
		document.getElementById(a).style.display = (divstatus=="hidden")?"none":"block";
		document.getElementById(a).style.visibility = divstatus;
	}
    //else if(document.getElementById) document.getElementById(a).style.visibility = divstatus;
    else if(document.layers) document.a.visibility = divstatus;
    else if(document.all.a) document.all.a.visibility = divstatus;
}

/*This function displays the busy dialog with a custom message... No message disposes of the busy window...*/
function busy(txt) {
	if(txt) {
		changeDiv('busy_holder','visible');
		writeDiv('busy','<IMG src="./themes.cgi?icon=loading" border=0><BR><BR>'+txt);
	}
	else {if(document.getElementById('reload')) changeDiv('reload','hidden');changeDiv('busy_holder','hidden');changeDiv('busy','hidden');}
}

/*This function displays the error dialog with a custom message...*/
function showError(txt) {
	if(txt) {
		changeDiv('busy_holder','visible');
		writeDiv('busy','<IMG src="./themes.cgi?icon=warn" border=0><BR><BR><B>'+txt+'</B><DIV name="reload" id="reload"></DIV><A HREF="">Reload Wefis</A>');
	}
	else {if(document.getElementById('reload')) changeDiv('reload','hidden');changeDiv('busy_holder','hidden');changeDiv('busy','hidden');}
}


/*The following function gets data from the div, cleans it, and returns...*/
function getData(what) {
	var r = ElementValue(what);
	if(r) {
		if(r.match(/\r/gi)) r = r.replace(/\r/gi,'');
		return r;
	}
	else return r;
}

/*The following function sets an element's value...*/
function setData(where,what) {
	if(document.getElementById) document.getElementById(where).value = what;
	else if(document.links) document.where.value = what;
	else if(document.all.name) document.all.where.value = what;
}

/*The folowing function creates the GOTO box...*/
function writeGoto() {
	var html='';
	html+='<select size=1 width=100 name=\"goto_locbar\" id=\"goto_locbar\" onChange="browseTo(ElementValue(\'goto_locbar\'));">';
	var data = getData('raw');
	var current = getData('location');
	var finfo = data.split('\n');	//split each newline!
	
	for(var i=0;i<finfo.length;i++) {
		var name = finfo[i].split('|');
		if(name[0] && name[1]=='directory') {	//display only directories!! ;-)
			if(name[0]==current) html+='<OPTION value="'+name[0]+'" SELECTED>'+current+'</OPTION>';	//select current directory!!
			else html+='<OPTION value="'+name[0]+'">'+name[0]+'</OPTION>';
		}
	}
	html+='<OPTION value="Refresh"> ** Refresh ** </OPTION>';
	writeDiv('locbar',html+'</SELECT>');
}

/*This function returns whether the user is a guest user... */
function guestUser() {
	if(getData('guest')) {
		writeDiv('list','<TABLE width="500"><TR><TD><IMG SRC="./themes.cgi?icon=warn" BORDER=0></TD><TD>The following error occurred:<BR><B>You are a guest user. Guest users cannot perform this (non-readonly) action. Sorry.</B><BR><A HREF="javascript:browseTo();">Continue</A></TD></TR></TABLE><BR>');
		return true;
	}
	return false;
}

/* This returns whether a particular option is on or off... */
function getOption(what) {
	var opts = getData('options').split('|');
	for(var i=0;i<opts.length;i++) if(opts[i].split('=')[0]==what) return (opts[i].split('=')[1].match(/(on|true|1)/));
	alert(what+' not found!');
	return false;
}

/*This function clears the left frame(s)...*/
function clearLeft() {
	displayHide='';
	writeDiv('fileinfo',' ');
	writeDiv('preview',' ');
	if(document.getElementById('cvs')) changeDiv('cvs','hidden');		//some old browsers do not recognise CANVAS as a tag!!
	changeDiv('canvascontainer','hidden');
	changeDiv('one','hidden');
	if(document.getElementById('upload').style.display!="none" && document.getElementById('upload-content') && document.getElementById('upload-content').style.display!="none") upload_hidedetails(true);
}

/*The following function displays the success window with the given text, or hides it...*/
function success(txt) {
	if(txt) {
		writeDiv('success','<B>'+txt+'</B>');
		setTimeout('success();',5000);		//hide this div after a while...
	}
	else changeDiv('success','hidden');
}




