/********************************************************************************************
	Secondary Javascript file for Wefis 1.4
	Written in April 2006
	This file is an integral part of Wefis, and code herein is licensed under GPL.
	If you use code in these files, please keep the following lines in the code:
	
	Programmed by Franois Botman from Wefis (http://wefis.sf.net).
	If you find bugs, please report them here: franchie@users.sourceforge.net
***********************************************************************************************/

/**********************************************************************************************
	Other.js; contains all the functions to manage diverse activity not covered by the other files...
	Dependancies; ajax.js, main.js
**********************************************************************************************/
var f = 0;
var upload_id=0;
var upload_num=0;
var upload_fail=0;
var upload_max = 10;
var uploading_text = "Uploading...";

/**********************************************************************************************
	New file upload forms and functions.
	This is a fully "ajaxed" way of seamlessly uploading files without reloading the page.
	We thus avoid the refresh problems, etc...
**********************************************************************************************/
window.onbeforeunload=function() {		// stop closing the window if files are still uploading!
	if(upload_num && upload_num>0) {
		return 'Some files are still being uploaded. If you close Wefis, the upload will be cancelled.';
	}
}
function upload_shortenName(name) {
	var a = name.split('/');
	if(a.length==1) a = name.split('\\');		//we are loading from a windows drive...
	return a[a.length-1];
}
function upload_success(name) {
	if(!document.getElementById('uploaded_file_'+upload_shortenName(name))) return;
	document.getElementById('uploaded_file_'+upload_shortenName(name)+'_icon').innerHTML = '<IMG SRC="./themes.cgi?icon=ok" BORDER=0 />';
	document.getElementById('uploaded_file_'+upload_shortenName(name)+'_C1').innerHTML = '<I><B>Completed!</B></I>';
	
	var raw = getData('raw');
	var l = document.getElementById('upload_info_'+upload_shortenName(name)).value;
	raw=raw+''+l+''+upload_shortenName(name)+'|file|<I>Just now</I>|<I>Just now</I>|<I>Just now</I>|rwxr-xr-x (0755)|1\n';
	setData('raw',raw);
	if((getData('location') == l) && !document.getElementById('content') && (document.getElementById('upload_summary').style.display!="none")) {
		browseTo();	//update current view if we are watching that particular directory... (but not saving a file!)
	}
	
	upload_fail--;
	upload_num--;
	upload_update();
}
function upload_failure(name,comment) {
	if(!document.getElementById('uploaded_file_'+upload_shortenName(name))) return;
	upload_fail++;
	upload_update();
	if(document.getElementById('uploaded_file_'+upload_shortenName(name)+'_C1').innerHTML != uploading_text) return;
	document.getElementById('uploaded_file_'+upload_shortenName(name)+'_icon').innerHTML = '<IMG SRC="./themes.cgi?icon=notok" BORDER=0 />';
	if(!comment) document.getElementById('uploaded_file_'+upload_shortenName(name)+'_C1').innerHTML = '<B>Failure!</B> Connection timed out!';
	else document.getElementById('uploaded_file_'+upload_shortenName(name)+'_C1').innerHTML = '<B>Failure!</B> '+comment;
}
function upload_uploadfile(name,form) {
	form.mode.value    = document.getElementById('upload_mode').value;
	form.replace.value = document.getElementById('upload_replace').checked;
	form.path.value	   = getData('location');
	if(document.getElementById('uploaded_file_'+upload_shortenName(name))) {
		if(!confirm('This file has already been sent to the upload queue. Should it be uploaded again?')) return;		//allow cancel of uploaded file!
		if((form.replace.value=="false") && confirm('The upload is currently in non-replace mode. Do you wish to upload this file in replace mode?')) form.replace.value=true;
	}
	upload_num++;
	var table = document.getElementById('uploaded_files');
	if(upload_id==0) {		//table has not yet been quite completed...
		var row = table.insertRow(0);
		var cell = row.insertCell(0);
		var cell = row.insertCell(1);
		cell.innerHTML = '<B>Name</B>';
		var cell = row.insertCell(2);
		cell.innerHTML = '<B>Status</B>';
	}
	if(!document.getElementById('uploaded_file_'+upload_shortenName(name))) {
		var row = table.insertRow(upload_id+1);
		row.id = 'uploaded_file_'+upload_shortenName(name);
		var cell = row.insertCell(0);
		cell.id = 'uploaded_file_'+upload_shortenName(name)+'_icon';
		cell.innerHTML = '<IMG SRC="./themes.cgi?icon=loading" BORDER=0 HEIGHT=20 />';
		var cell = row.insertCell(1);
		cell.innerHTML=upload_shortenName(name)+'<INPUT TYPE="hidden" id="upload_info_'+upload_shortenName(name)+'" value="'+getData('location')+'">';
		var cell = row.insertCell(2);
		cell.id = 'uploaded_file_'+upload_shortenName(name)+'_C1';
		cell.innerHTML = uploading_text;
	}
	else {
		document.getElementById('uploaded_file_'+upload_shortenName(name)+'_icon').innerHTML = '<IMG SRC="./themes.cgi?icon=loading" BORDER=0 HEIGHT=20 />';
		document.getElementById('uploaded_file_'+upload_shortenName(name)+'_C1').innerHTML = uploading_text;
	}
	/*var cell = row.insertCell(2);
	cell.id = 'uploaded_file_'+upload_shortenName(name)+'_C2';
	cell.innerHTML = "Cancel";*/
	form.submit();
	document.getElementById('upload_frame_'+upload_id).style.display="none";
	upload_id++;
	iframe = document.createElement('IFRAME');
	iframe.id = 'upload_frame_'+upload_id;
	iframe.frameborder = '0';
	iframe.src = "./index.cgi?action=upload-form";
	iframe.className="upload_frame";
	document.getElementById('upload_iframe_holder').appendChild(iframe);
	upload_update();
}
function upload_showdetails() {
	writeDiv('list',"");
	document.getElementById('up_p').innerHTML = getData('location');
	document.getElementById('upload_summary').style.display='none';
	document.getElementById('upload-content').style.display='block';
	if(upload_fail) {upload_num-=upload_fail;upload_fail=0;}
}
function upload_hidedetails(b) {
	upload_update();
	if(document.getElementById('upload_summary')) document.getElementById('upload_summary').style.display="block";
	if(document.getElementById('upload-content')) document.getElementById('upload-content').style.display="none";
	if(!upload_num) {
		document.getElementById('upload').innerHTML=' ';
		document.getElementById('upload').style.display="none";
	}
	if(!b) browseTo();
}
function upload_update() {
	if(!document.getElementById('upload_summary')) return;
	if(!upload_fail) {
		document.getElementById('upload_summary').innerHTML='<CENTER><B>Uploading '+upload_num+' item(s)...</B></CENTER>';
		if(!upload_num) {
			if(document.getElementById('upload_summary').style.display!="none") {
				success("All uploads have completed!");
				document.getElementById('upload').innerHTML=' ';
				document.getElementById('upload').style.display="none";
			}
		}
	}
	else {
		document.getElementById('upload_summary').innerHTML = '<IMG SRC="./themes.cgi?icon=notok" BORDER=0 /><B> '+upload_fail+' items failed to be uploaded</B>, click here for more info...';
	}
}
function upload_makepage() {
	if(document.getElementById('upload').style.display!="none" && document.getElementById('upload_summary')) {
		if(document.getElementById('upload_summary').style.display=="none") return upload_hidedetails();
		else return upload_showdetails();
	}
	clearLeft();
	if(guestUser()) return;
	upload_id=0;
	upload_num=0;
	upload_fail=0;
	var html='<DIV id="upload-content"><H1>Upload Files</H1>You can upload <B>';
	var size = parseInt(getData('quota')) - parseInt(getData('quota_used'));
	if(size>(1024*1024)) html+=parseInt((size/(1024*1024)))+' Mb';
	else if(size>1024) html+=parseInt((size/1024))+' kb';
	else html+=size+' b';
	html+='<IMG SRC="./themes.cgi?icon=notok" BORDER=0 HEIGHT=0 style="display:none;" />';		//pre-load important failure images...
	html+='</B><BR>The following files will be uploaded to <B><SPAN id="up_p">'+getData('location')+'</SPAN></B>:<BR><BR>';
	html+='<DIV id="upload_iframe_holder">';
	html+='<IFRAME frameborder=false id="upload_frame_0" src="./index.cgi?action=upload-form" class="upload_frame"></IFRAME>';
	html+='</DIV>';
	html+='<BR><B>Mode:</B> <select id="upload_mode" name="mode"><option value="auto">AUTO<option value="binary">BINARY<option value="ascii">ASCII</select><label for="upload_replace"><input type=checkbox id="upload_replace" name="upload_replace" value="replace" id="replace">Replace files?</label>';
	html+='<BR><CENTER><TABLE id="uploaded_files"></TABLE>';
	html+='<INPUT TYPE="button" value="Close" onclick="upload_hidedetails();" style="width:100px;"></CENTER><BR>';
	html+='</DIV><DIV id="upload_summary" style="display: none;"></DIV>';
	writeDiv('upload',html);
	writeDiv('list',"");
	document.getElementById('upload').style.display="block";
	document.getElementById('upload_summary').onclick = upload_showdetails;
}
//***************************************** END ***********************************************

/* This function add a line to add an extra file! */
function addInput () {
  if (document.all || document.getElementById) {
    var table = document.all ? document.all.formElems : document.getElementById('formElems');
    var row = table.insertRow(++f);
    if (document.all) {
      var cell = row.insertCell(0);
      cell.innerHTML = '<INPUT TYPE="file" NAME="fileName' + f + '" ONCHANGE="addInput();">';
    }
    else {
      var cell = row.insertCell(0);
      var input = document.createElement('INPUT');
      input.setAttribute('type', 'file');
      input.name = 'fileName' + f;
      input.onchange = function () { addInput(); };
      cell.appendChild(input);
    }
  }
}

/* This function creates the upload form!*/
function uploadForm() {
	if(!getOption('compatibility_upload')) return upload_makepage();		//load older version for compatibility with older browsers?
	clearLeft();
	if(document.getElementById('formElems')) {browseTo();return;}			//already loaded!!
	if(guestUser()) return;
	var html='<H1>Upload Files</H1>';
	html+='You can upload <B>';
	var size = parseInt(getData('quota')) - parseInt(getData('quota_used'));
	if(size>(1024*1024)) html+=parseInt((size/(1024*1024)))+' Mb';
	else if(size>1024) html+=parseInt((size/1024))+' kb';
	else html+=size+' b';
	html+='</B><BR>The following files will be uploaded to <B>'+getData('location')+'</B>:<BR><BR>';
	html+='<FORM NAME="formName" METHOD="post" ENCTYPE="multipart/form-data" ACTION="index.cgi"><INPUT TYPE=hidden name="action" value="upload-doit"><INPUT TYPE=hidden name="path" value="'+getData('location')+'"><TABLE ID="formElems" width=600><TR><TD><INPUT TYPE="file" NAME="fileName0" ONCHANGE="addInput();"></TD><TD></TD></TR><TR><TD><BR><B>Mode:</B> <select name="mode"><option value="auto">AUTO<option value="binary">BINARY<option value="ascii">ASCII</select><label for="replace"><input type=checkbox name="replace" value="replace" id="replace">Replace files?</label></TD></TR><TR><TD><INPUT TYPE="submit" value="Upload" onclick="busy(\'Please wait: Uploading File(s)\');"><INPUT TYPE=button onclick="browseTo();" value="Close"></td></tr></TR></TABLE>';
	writeDiv('list',html);
}

/* This function creates the new File form... */
function newFileForm() {
	clearLeft();
	if(guestUser()) return;
	if(document.getElementById('new_file_name')) {browseTo();return;}		//already loaded!!
	var html='<TABLE width=600><TR><TD>The new file will be created in '+getData('location')+'.<br><BR><form method="post" name="f3" action="javascript:create_file(ElementValue(\'new_file_name\'));">File name: <input type=text name="new_file_name" id="new_file_name" value=""><br><input type=submit value="-- create file --"><INPUT TYPE=button onclick="browseTo();" value="Close"></form></TD></TR></TABLE>';
	writeDiv('list',html);
	if(document.getElementById('new_file_name')) document.getElementById('new_file_name').focus();
}

/* This function creates the new Dir form... */
function newDirForm() {
	clearLeft();
	if(guestUser()) return;
	if(document.getElementById('new_dir_name')) {browseTo();return;}		//already loaded!!
	var html='<TABLE width=600><TR><TD>The new folder will be created in '+getData('location')+'. It will be created empty; to edit the file you will need to click on \'edit\' in the preview pane.<br><BR><form method="post" name="f3" action="javascript:create_dir(ElementValue(\'new_dir_name\'));">Folder name: <input type=text name="new_dir_name" id="new_dir_name" value=""><br><input type=submit value="-- create folder --"><INPUT TYPE=button onclick="browseTo();" value="Close"></form></TD></TR></TABLE>';
	writeDiv('list',html);
	if(document.getElementById('new_dir_name')) document.getElementById('new_dir_name').focus();
}

/* This function returns true if the favorites icon should be displayed (not in fav) */
function showFavIcon(path) {
	if(!path) path = getData('location');
	if(path=='/') return false;
	var data = getData('favdata');
	if(!data) return true;		//changed; if not in list, add it!!!
	var parts = data.split('|');
	for(var i=0;i<parts.length;i++) {
		if(parts[i]==path) return false;
	}
	return true;
}


/*This function adds the current path to the favorites...*/
function addToFav(path) {
	if(!path) path = getData('location');
	setData('favdata',getData('favdata')+path+'|');
	sendData('addFav',path,'Favorites updated...');
}

/*This function removes the given path from the favorites...*/
function removeFav(path) {
	if(!path) return;
	sendData('removeFav',path,'Favorites updated...');
	browseTo();
}

/*This function displays the favorites...*/
function ShowFav() {
	clearLeft();
	var html='<TABLE WIDTH=600><TR><TD><IMG SRC="./themes.cgi?icon=fav" BORDER=0></TD><TD><H1>Favorites</H1></TD><TD><IMG SRC="./themes.cgi?icon=fav" BORDER=0></TD></TR><TR><TD><B>Location:</B></TD><TD><B>Actions:</B></TD></TR>';
	if(!getData('favdata')) html+='<TR><TD>No favourites have been set yet...</TD></TR>';
	else {
		var d = getData('favdata').split('|');
		for(var i=0;i<d.length;i++) {
			if(d[i]) {
				html+= '<TR><TD><A HREF="#" style="color:#000000;" onclick="browseTo(\''+d[i]+'\');">'+d[i]+'</A></TD><TD>';
				html+='<A HREF="javascript:removeFav(\''+d[i]+'\');">Remove</A> | ...</TD></TR>';
			}
		}
	}
	html+='</TABLE><BR><CENTER><BR><A HREF="#" onclick="browseTo();"><B>Back</B></A></CENTER>';
	writeDiv('list',html);
}


/*The following function generates the 'MORE' menu buttons...*/
function showMore() {
	clearLeft();
	if(document.getElementById('moreopen')) {browseTo();return;}		//already loaded!!
	var html='<TABLE WIDTH=600><TR><TD WIDTH=70 onclick="showSettings();" onmouseover="writeDiv(\'status\',\'Configure the behaviour of WEFIS\');"><CENTER><A HREF="#"><IMG SRC="./themes.cgi?icon=settings" BORDER=0><BR>Settings</A></CENTER></TD><TD>This option allows you to change the configuration of your copy of WEFIS...</TD></TR>';
	if(getData('admin')) html+='<TR><TD WIDTH=70 onclick="fetch(\'list\',\'admin\');" onmouseover="writeDiv(\'status\',\'Change settings for Wefis users\');"><CENTER><A HREF="#"><IMG SRC="./themes.cgi?icon=admin" BORDER=0><BR>Admin</A></CENTER></TD><TD>This option allows you to manage users using wefis...</TD></TR>';
	
	html+='<TR><TD WIDTH=70 onclick="ShowFav();" onmouseover="writeDiv(\'status\',\'Manage your Favorites\');"><CENTER><A HREF="#"><IMG SRC="./themes.cgi?icon=fav" BORDER=0><BR>Favorites</A></CENTER></TD><TD>This option allows you to go to your favorites page, or add the current directory to the favorites.</TD></TR>';
	
	html+='<TR><TD WIDTH=70 onclick="fetch(\'list\',\'help\');setTimeout(\'fetch(\\\'theme_aut\\\',\\\'theme_copyright\\\');\',1000);" onmouseover="writeDiv(\'status\',\'View Help and Credits\');"><CENTER><A HREF="#"><IMG SRC="./themes.cgi?icon=help" BORDER=0><BR>Help</A></CENTER></TD><TD>Get Help and view copyright information, as well as credits, and other details...</TD></TR>';
	
	html+='<TR><TD WIDTH=70 onclick="showStats();" onmouseover="writeDiv(\'status\',\'View Statistics about your filespace usage and quota...\');"><CENTER><A HREF="#"><IMG SRC="./themes.cgi?icon=stats" BORDER=0><BR>Stats</A></CENTER></TD><TD>View your quota and filespace; See where space is being used up! Provides a global and per directory view of the disk usage...</TD></TR>';
	
	html+='<TR><TD WIDTH=70 onclick="busy(\'Logout: contacting PRASI\');window.location=getData(\'logout\');"><CENTER><A HREF="#"><IMG SRC="./themes.cgi?icon=logout" BORDER=0><BR>Logout</A></CENTER></TD><TD>This option allows you to log out of the current session (recommended if you are on a public server).</TD></TR>';
	html+='</TABLE><BR><CENTER><A HREF="javascript:browseTo();">Close</A></CENTER><INPUT TYPE=hidden id="moreopen" name="moreopen" value="yes">';
	writeDiv('list',html);
}


/*This function changes the small edit to a fullscreen one! */
function Edit_FullScreen() {
	var html = '<HTML><HEAD><TITLE>Editing file: '+getFileName(getData('file'))+'</TITLE></HEAD><BODY>\n';
	html+='<SCRIPT src="./js/lang/main_english.js"></SCRIPT>';
	html+='<SCRIPT src="./js/lang/data_english.js"></SCRIPT>';
	html+='<SCRIPT>window.onresize=resized;function resized(){scrollTo(0,0);var y = window.innerHeight ? window.innerHeight :document.body.clientHeight;if(document.getElementById(\'content_full\')) document.getElementById(\'content_full\').style.height=Math.max(20,y-60);}';
	html+='</SCRIPT>\n\n<DIV id="send" name="send" style="visibility: hidden;"></DIV>\n<DIV id="d8er" name="d8er">';
	html+='<FORM action="javascript:saveFile(\'content_full\',\''+getData('file')+'\',2);">';	//file
	html+='\n<textarea name="content_full" id="content_full" style="width:100%;">';
	var dt = getData('content');
	dt = dt.replace(/<\/TEXTAREA>/gi,'&lt;/TEXTAREA&gt;');
	html+=dt;
	html+='</TEXTAREA><BR> <input type=button value="Save" onclick="writeDiv(\'send\',\'<CENTER><B><BR>Please Wait: Saving File\');saveFile(\'content_full\',\''+getData('file')+'\',-1);"> <input type=submit value="Save&Close" onclick="changeDiv(\'d8er\',\'hidden\');writeDiv(\'send\',\'<CENTER><B><BR>Please Wait: Saving File\');"> ';
	html+='<INPUT TYPE=hidden name="file" id="file" value="'+getData('file')+'">';
	html+=' | <a href="#" onClick="window.close();">cancel</a></FORM></DIV><SCRIPT>resized();</SCRIPT>\n\n</BODY></HTML>';
	var wnd = window.open(''/*'./action.cgi?action=fullscr'*/,'Fullscreen','resizable=yes,scrollbars=yes,status=no,width=800,height=640');
	if(!wnd) {alert('Grrr... A popup blocker is preventing Wefis from opening the window!');return;}
	/*wnd.onload = function() {*/wnd.document.write(html);//}
	browseTo();
}


/*This function will display the settings dialog...*/
function showSettings() {
	var html = '<H1>Settings:</H1><FORM name="settings"><TABLE width=600><TR><TD><label for="index"><input type=checkbox name="index" id="index"';
	if(getOption('index')) html+='CHECKED';
	html+='>Generation of index files on directory creation. </label>';
	
	html+='</TD></TR><TR><TD><label for="plug"><input type=checkbox name="plug" id="plug"';
	if(getOption('plugin')) html+='CHECKED';
	html+='>Plugins enabled. </label>';
	
	html+='</TD></TR><TR><TD><label for="tool"><input type=checkbox name="tool" id="tool"';
	if(!getOption('tool_labels')) html+='CHECKED';
	html+='>Minimised Toolbar. </label>';
	
	html+='</TD></TR><TR><TD><label for="compat"><input type=checkbox name="compat" id="compat"';
	if(getOption('compatibility_upload')) html+='CHECKED';
	html+='>Use compatibility upload mode. </label>';
	
	html+='</TD></TR><TR><TD>Theme to use: <SELECT name="theme_choice" id="theme_choice" onclick="changeCSS()">';
	var t = ElementValue('iconsets').split('|');
	for(var i=0;i<t.length;i++) {
		if(ElementValue('iconset') == t[i]) html+='<OPTION SELECTED>'+t[i]+'</OPTION>';
		else if(t[i]) html+='<OPTION>'+t[i]+'</OPTION>';
	}
	html+='</SELECT>';
	
	html+='</TD></TR></TABLE>';
	html+='<BR><INPUT TYPE=button value="Save settings" onClick="saveSettings();"> ';
	html+=' <INPUT TYPE=button value="Cancel" onClick="browseTo();"> ';
	html+=' <INPUT TYPE=button value="Contact Admin" onclick="fetch(\'list\',\'mailadmin\');">';
	html+='</FORM><BR><BR>';
	
	writeDiv('list',html);
}

// Updates the css for an instant ("live") preview...
function changeCSS() {
	return;	//Bad idea: fails to load in some browsers!
	if(!document.getElementById('theme_choice')) return;
	var IE = document.all?true:false;
	if(IE) return;	//prevent IE errors...
	var theme = ElementValue('theme_choice');
	//only change if we have to!
	if(document.getElementById('css_theme_select').innerHTML!='@import "./themes/'+theme+'/layout.css";') 
		document.getElementById('css_theme_select').innerHTML = '@import "./themes/'+theme+'/layout.css";';
}
/* This function actually saves the settings...*/
/* NOTE: we have a problem for the toolbar setting!! THIS IS A BUG, but cannot be easily fixed...*/
function saveSettings() {
	sendData('saveset&tool='+document.settings.tool.checked+'&indexf='+document.settings.index.checked+'&plug='+document.settings.plug.checked+'&compat='+document.settings.compat.checked+'&theme='+ElementValue('theme_choice'),'null','Settings Saved');
	//apply all possible changes!
	var oldtool = getOption('tool_labels');
	var oldcompat = getOption('compatibility_upload');
	setData('options','index='+((document.settings.index.checked)?'on':'off')+'|tool_labels='+oldtool+'|plugin='+((document.settings.plug.checked)?'on':'off')+'|compatibility_upload='+((document.settings.compat.checked)?'on':'off')+'|');
	if((document.settings.tool.checked&&oldtool) || (!document.settings.tool.checked&&!oldtool) ||(oldcompat&&!document.settings.compat.checked) || (document.settings.compat.checked&&!oldcompat)) {
		if(confirm('Some changes you have selected require a refresh before they can come into effect!\nDo you wish to do this now?')) window.location="./index.cgi?forcereload=okay";
	}
	changeCSS();
	browseTo();
}



