/********************************************************************************************
	Secondary Javascript file for Wefis 1.4
	Written in April 2006
	This file is an integral part of Wefis, and code herein is licensed under GPL.
	If you use code in these files, please keep the following lines in the code:
	
	Programmed by Franois Botman from Wefis (http://wefis.sf.net).
	If you find bugs, please report them here: franchie@users.sourceforge.net
***********************************************************************************************/

/**********************************************************************************************
	Search.js; contains all the functions related to some sort of search utility...
	Dependancies; ajax.js, main.js
**********************************************************************************************/


function search_transform_regexp() {
	var search = ElementValue('search_query');
	if(document.getElementById('search_regexp').checked) {
		if(search.match(/\//gi)) {find();return;}	//ie: is already a valid regexp!
		search = search.replace(/\\/gi,'\\\\');
		if(search.charAt(0)=='*') search = search.replace(/\*star/i,'');		//remove first star!!
		search = search.replace(/\./gi,'\\.');
		if(search) {document.getElementById('search_query').value = '/'+search+'/gi';find();}
		else document.getElementById('search_query').value = '/[what to find]/gi';
	}
	else {
		var reg = search.split('/');
		if(!reg[1]) {document.getElementById('search_query').value = '';return;}
		reg[1] = reg[1].replace(/\//gi,'');
		reg[1] = reg[1].replace(/\\\*/gi,'*');
		reg[1] = reg[1].replace(/\\\./gi,'.');
		reg[1] = reg[1].replace(/\\\\/gi,'\\');
		document.getElementById('search_query').value = reg[1];
		if(reg[1]) find();
	}
}

function show_search() {
	clearLeft();
	if(document.getElementById('search_results')) {browseTo();return;}	//already loaded...
	writeDiv('list','<DIV id="search"><INPUT TYPE=text id="search_query" onKeyUp="find();"><A HREF="javascript:find();">Search...</A> <LABEL for="search_regexp"><INPUT TYPE=checkbox id="search_regexp" onclick="search_transform_regexp();">Regexp</LABEL> <LABEL for="search_multimode"><INPUT TYPE=checkbox id="search_multimode" onclick="find();">Show CheckBoxes</LABEL> <INPUT TYPE=button onclick="browseTo();" value="Close"></DIV><BR><DIV name="search_results" id="search_results">Please enter a search request...</DIV><BR>');
	if(document.getElementById('search_query')) document.getElementById('search_query').focus();
}

function find() {
	//regexp /what/gi >> g=global, i=ignore case
	var data = getData('raw');
	var search = ElementValue('search_query');
	
	if(!search) {writeDiv('search_results','<I>Please specify a search pattern...</I>');return;}
	if(document.getElementById('search_multimode').checked) {return find_multimode();}
	
	var bits = data.split('\n');
	var html='';
	
	try {
		if(!document.getElementById('search_regexp').checked) {
			if(search.charAt(0)=='*') search=search.replace(/\*/i,'');	//remove starts in position one: unsupported by regexp!
			search=search.replace(/\./i,'\\.');							//replace dots! these are misleading!!
			var regexp = new RegExp(search,"gi");
		}
		else {
			var reg = search.split('/');		//reg[0] will be null by definition!!
			if(reg[1] && reg[2]) var regexp = new RegExp(reg[1],reg[2]);
			else {writeDiv('search_results','<B><I>The regexp you specified is invalid!</B></I>');return;}
		}
		//TODO: check for valid regexp!!
		if(!regexp) {writeDiv('search_results','Your search criteria is invalid; please enable regexp if you are using wildcards...'); return;}
		var highlight = regexp.toString().split('/');		//highlighting: get query string from regexp, and only valid chars!!
		if(highlight[1]) {
			for(var i=0;highlight[1],i<highlight[1].length;i++) {
				var c = highlight[1].charAt(i);
				if(!c.match(/[A-Z,a-z,0-9]/gi)) {highlight[1]="";break;}
			}
		}
		
		for(var i=0;i<bits.length;i++) {
			var q = bits[i].split('|')[0];
			if(q.match(regexp)) {
				var name = q.split('/');
				var path = '';
				
				for(var z=0;z<(name.length-1);z++) if(name[z]) path+='/'+name[z];
				path+='/';
				
				
				if(highlight[1]) {		//if highlighting, highlight
					if(name[(name.length-1)]) var name_highlighted = name[(name.length-1)].replace(regexp,'<B><I>'+highlight[1]+'</I></B>');
					var path_highlighted = path.replace(regexp,'<B><I>'+highlight[1]+'</I></B>');
				}
				else {					//otherwise display!
					if(name[(name.length-1)]) var name_highlighted = name[(name.length-1)];
					var path_highlighted = path;
				}
				
				if(name[(name.length-1)]) {
					if(!html) html = '<TABLE width=500><TR><TD><B>Filename:</B></TD><TD><B>Folder:</B></TD></TR>';
					html+= '<TR onMouseOver="this.style.backgroundColor=\'#F5F5F5\';" onMouseOut="this.style.backgroundColor=\'#FFFFFF\';" onClick="browseTo(\''+path+'\',\''+name[(name.length-1)]+'\');"><TD>';
					
					html+= name_highlighted+'</TD><TD>';
					html+=path_highlighted+'</TD></TR>\n';
				}
			}
		}
		if(html) writeDiv('search_results',html+'</TABLE>'); 
		else writeDiv('search_results','No results found. Please try widening your search!');
	} catch(e) {
		writeDiv('search_results','<B><I>Invalid search criteria...</I></B>'+e);
	}
}

function find_multimode() {
	//regexp /what/gi >> g=global, i=ignore case
	var data = getData('raw');
	var search = ElementValue('search_query');
	
	if(!search) {writeDiv('search_results','<I>Please specify a search pattern...</I>');return;}

	var bits = data.split('\n');
	var html='';
	try {
		if(!document.getElementById('search_regexp').checked) {
			if(search.charAt(0)=='*') search=search.replace(/\*/i,'');	//remove starts in position one: unsupported by regexp!
			search=search.replace(/\./i,'\\.');							//replace dots! these are misleading!!
			var regexp = new RegExp(search,"gi");
		}
		else {
			var reg = search.split('/');		//reg[0] will be null by definition!!
			if(reg[1] && reg[2]) var regexp = new RegExp(reg[1],reg[2]);
			else {writeDiv('search_results','<B><I>The regexp you specified is invalid!</B></I>');return;}
		}
		//TODO: check for valid regexp!!
		if(!regexp) {writeDiv('search_results','Your search criteria is invalid; please enable regexp if you are using wildcards...'); return;}
		var highlight = regexp.toString().split('/');		//highlighting: get query string from regexp, and only valid chars!!
		if(highlight[1]) {
			for(var i=0;highlight[1],i<highlight[1].length;i++) {
				var c = highlight[1].charAt(i);
				if(!c.match(/[A-Z,a-z,0-9]/gi)) {highlight[1]="";break;}
			}
		}
		
		for(var i=0;i<bits.length;i++) {
			var q = bits[i].split('|')[0];
			if(q.match(regexp)) {
				var name = q.split('/');
				var path = '';
				
				for(var z=0;z<(name.length-1);z++) if(name[z]) path+='/'+name[z];
				path+='/';
				
				
				if(highlight[1]) {		//if highlighting, highlight
					if(name[(name.length-1)]) var name_highlighted = name[(name.length-1)].replace(regexp,'<B><I>'+highlight[1]+'</I></B>');
					var path_highlighted = path.replace(regexp,'<B><I>'+highlight[1]+'</I></B>');
				}
				else {					//otherwise display!
					if(name[(name.length-1)]) var name_highlighted = name[(name.length-1)];
					var path_highlighted = path;
				}
				
				if(name[(name.length-1)]) {
					if(!html) {
						html = '<FORM name="multiform" id="multiform" action="javascript:search_multimode_submit(this);">';
						html+=multimode_selectbuttons(true);
						html+='<TABLE width=500><TR><TD></TD><TD><B>Filename:</B></TD><TD><B>Folder:</B></TD></TR>';
					}
					html+= '<TR onMouseOver="this.style.backgroundColor=\'#F5F5F5\';" onMouseOut="this.style.backgroundColor=\'#FFFFFF\';"><TD>';
					//checkbox, etc...
					html+='<INPUT TYPE=checkbox name="cb" id="'+path+name[(name.length-1)]+'" value="'+path+name[(name.length-1)]+'">';
					html+='</TD><TD>';					
					html+= '<LABEL for="'+path+name[(name.length-1)]+'">'+name_highlighted+'</LABEL></TD><TD>';
					html+='<LABEL for="'+path+name[(name.length-1)]+'">'+path_highlighted+'</LABEL></TD></TR>\n';
				}
			}
		}
		if(html) {
			//append the submit multi_mod action, etc...
			html+='</TABLE><A NAME="tbottom"></A>';
			html+=multimode_selectbuttons(false);
			html+='<BR><BR><select name="multi_action" id="multi_action"><option value="download">download</option><option value="delete">delete</option><option value="chmod">chmod</option><option value="copy">copy to</option><option value="move">move to</option>';
	
			var p = getData('plugins');
			if(p && getOption('plugin')) {
				var plugs = p.split('|');
				for(var i=0;i<plugs.length;i++) {
					var b = plugs[i].split(',');
					if(b[0] && b[1]) {html+='<option value="'+b[1]+'" SELECTED>'+b[0]+'</option>';}
				}
			}
	
			html+='</select><input type=text name="param1" id="param1" value="" size=6>';
			html+='<input type=submit value="perform"></FORM>';
			writeDiv('search_results',html); 
		}
		else writeDiv('search_results','No results found. Please try widening your search!');
	} catch(e) {
		writeDiv('search_results','<B><I>Invalid search criteria...</I></B>'+e);
	}
}

function search_multimode_submit(form)
{
	//okay... search multimode is always based from root /. Fix, to ensure that it is!
	displayMode = 1;	//switch mode, so that the user gets redirected to a normal browser upon success (and an irrelevant 'multimode' window upon failure)...
	var l = getData('location');
	setData('location','/');
	multimode_submit(form);
	setData('location',l);
}