#!/usr/bin/perl --

use CGI;
use CGI::Carp "fatalsToBrowser";
require "./lang-default.pl";
require "./config.pl";
require "./prasi.pl";
require "./internals.pl";
require "./email.pl";
use Net::OpenID::Consumer;
use Text::Wrap;
# use Digest::SHA1 qw(sha1 sha1_hex);

package PRASI;  # fully scoped

my $new_pw = "";  # need this as global or some archaic bits of the code will break

my $f = new CGI;

my $action=$f->param('action');
my $detectnocookies=$f->param('jo');
my $initial_user = $f->param('iuser');  # hidden feature
if($detectnocookies eq "1") { if(!get_session()) {
print "Content-type: text/html\n\n";
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$PRASI::lang::msg135
</center></td>
</tr></table>
";
exit;
} }
if($action eq "logout") {
my $session = get_session(); # no output
my $ret = $f->param('return');
# remove_cookie prints the content-type
if($session eq "") {
 print "Content-type: text/html\n\n";
} else {
 remove_cookie();
 delete_session($session);
}
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$PRASI::lang::msg03a<br>
$PRASI::lang::msg03b<br>
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg16\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
if($ret eq "") { } else {
 print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center><br>$PRASI::lang::msg04a <a href=\"$ret\">$ret</a>$PRASI::lang::msg04b<script>window.location=\"$ret\";</script></center></td>
</tr></table>";
}
exit;
}
if($action eq "login") {
# print the cookie if auth is good
authenticate();
exit;
}
if($action eq "ping") {
print "Content-type: text/html\n\n";
my $type = $f->param('type');
my $u = $f->param('user');
my $d = $f->param('data');
if($type eq "login") {remote_login_response($u);}
if($type eq "data") {(my $resp) = prasi_data($u,$d); print "$resp";}
if($type eq "userlist") {(my $resp) = prasi_userlist($d); print "$resp";}
if($type eq "save") {
 $n = $f->param('name');
 $s = $f->param('svc');
 prasi_save($u,$n,$d,$s);
 print "OK";
}
exit;
}
if($action eq "chk") {
print "Content-type: text/html\n\n";
my $n = $f->param('requires');
my $u=prasi_login("prasi",0);
if($u eq "") {
login_form();
exit;
}
fullcheck_service_requires($u,$n);
exit;
}
if($action eq "chk2") {
print "Content-type: text/html\n\n";
my $n = $f->param('requires');
my $u=prasi_login("prasi",0);
if($u eq "") {
login_form();
exit;
}
my $v = $f->param('vars');
my @words = split (/\+/, $v);
my $word = "";
foreach $word (@words) {
 if($word eq "") { } else {
  my $store = $f->param($word);
  open(IN, "> $PRASI::datatree/users/$u/$word") || die "$PRASI::lang::msg05 '$word'.";
  print IN "$store\n";
  close(IN);
  print "$word: $PRASI::lang::msg06 '$store'<br>";
 }
}
(my $h,$h,$h,my $g) = service_info($n);
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg07 <a href=\"$g\">$PRASI::lang::msg08</a>.<script>window.location=\"$g\";</script></center></td>
</tr></table>";
exit;
}
if($action eq "newuser") {
print "Content-type: text/html\n\n";
my $n = $f->param('name');
my $u = $f->param('user');
my $e = $f->param('email');
my $r = $f->param('reason');
if($n and $u and $e and $r) {
# no sanitising needed as we trust "$from", the rest is in email body.
send_email($from,"$PRASI::lang::msg09","$PRASI::lang::msg10a '$u' ('$n') $PRASI::lang::msg10b '$r'. $PRASI::lang::msg10c '$e'. $PRASI::lang::msg10d");
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg11</center></td>
</tr></table>";
} else {
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg140</center></td>
</tr></table>";
}
exit;
}
if($action eq "msg") {
print "Content-type: text/html\n\n";
my $u=prasi_login("prasi",0);
if($u eq "") {
login_form();
exit;
} else {
my $m=$f->param('m');
(my $addr) = prasi_data($u,"email");
chomp($addr);
if($addr eq "") {
 pretty_page();
 print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg12a '$u' $PRASI::lang::msg12b</center></td>
</tr></table>";
 exit;
 }
 send_email($from,"$PRASI::lang::msg13","$PRASI::lang::msg14a '$u' $PRASI::lang::msg14b '$addr'.\n\n\"$m\"");
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$u$PRASI::lang::msg15<br>
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg17\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
exit;
}
}
if($action eq "chgpw") {
print "Content-type: text/html\n\n";
my $u=prasi_login("prasi",0);
if($u eq "") {
login_form();
exit;
} else {
if($u eq "demo") {pretty_page();print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg141</center></td>
</tr></table>";exit;}
my $np=$f->param('pw');
if($np eq "") {
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$u$PRASI::lang::msg18
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg19\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
exit;
}
my $nh = main::md5_hex($np);
open(IN,">$PRASI::datatree/users/$u/password") || die "$PRASI::lang::msg20";
print IN "$nh";
close(IN);
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$u$PRASI::lang::msg21<br>
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg17\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
exit;
}
}
if($action eq "chglang") {
print "Content-type: text/html\n\n";
my $u=prasi_login("prasi",0);
if($u eq "") {
login_form();
exit;
} else {
if($u eq "demo") {pretty_page();print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg141</center></td>
</tr></table>";exit;}
my $np=$f->param('lang');
# does not matter if incorrect, defaults to english!
open(IN,">$PRASI::datatree/users/$u/language") || die "$PRASI::lang::msg133";
print IN "$np";
close(IN);
# to get the next text in that language, force soft re-login:
prasi_login("prasi",0); # discard result, we did it a few milliseconds ago
pretty_page();
if($PRASI::lang::version eq $PRASI::version) { } else {
 print "<body><script language=\"Javascript\">alert(\"The language file you have chosen is meant for Prasi version $PRASI::lang::version,\\nbut you have Prasi version $PRASI::version.\\nThis may cause some problems.\\nAsk your Prasi administrator to update the language packs.\");</script>";
 # the previous sentence is in English because it is the default language and might not show up for a 'bad' language pack if it was inside it.
}
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$u$PRASI::lang::msg134 '$np'<br>$PRASI::lang::msg139<br>
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg17\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
exit;
}
}
if($action eq "enable-openid") {
print "Content-type: text/html\n\n";
my $u=prasi_login("prasi",0);
if($u eq "") {
login_form();
exit;
} else {
if($u eq "demo") {pretty_page();print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg144</center></td>
</tr></table>";exit;}
my $np=$f->param('oid');
open(IN,">$PRASI::datatree/users/$u/openid") || die "$PRASI::lang::msg145";
print IN "$np";
close(IN);
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$PRASI::lang::msg146 '$np'<br>$PRASI::lang::msg139<br>
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg17\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
exit;
}
}
if($action eq "disable-openid") {
print "Content-type: text/html\n\n";
my $u=prasi_login("prasi",0);
if($u eq "") {
login_form();
exit;
} else {
if($u eq "demo") {pretty_page();print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg147</center></td>
</tr></table>";exit;}
unlink("$PRASI::datatree/users/$u/openid") || die "$PRASI::lang::msg148";
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$PRASI::lang::msg149<br>$PRASI::lang::msg139<br>
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg17\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
exit;
}
}
if($action eq "pwforgot") {
print "Content-type: text/html\n\n";
my $u = $f->param('user');
(my $addr) = prasi_data($u,"email");
chomp($addr);
if($addr eq "") {
 pretty_page();
 print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg12a '$u' $PRASI::lang::msg12b</center></td>
</tr></table>";
 exit;
 }
pretty_page();
$obfuscated = "$addr";
$obfuscated =~ s/(.*?)\@(.*?)/\(hidden\)\@$2/gi;
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg22 '$obfuscated'!</center></td>
</tr></table>";
$new_pw = ''; # GLOBAL
generate_pw();
my $hash = main::md5_hex($new_pw);
open(IN,">$PRASI::datatree/users/$u/password") || die "$PRASI::lang::msg20";
print IN "$hash";
close(IN);
send_email($addr,"$PRASI::lang::msg23","$PRASI::lang::msg24a '$new_pw'. $PRASI::lang::msg24b");
exit;
}
if($action eq "error") {
print "Content-type: text/html\n\n";
errorform();
exit;
}
if($action eq "miniform") {
print "Content-type: text/html\n\n";
# show mini login screen
# if the user is logged in already, then don't show the miniform...
# (prevents infinite loops)
my $silence = prasi_login("prasi",0);
if(!$initial_user and $silence) {$initial_user = $silence;}
if($silence eq "") {
 # not logged in; show the form
 login_miniform("");
 exit;
} else {
 # logged in; fall through to prasi main screen
 $action = ""; # in order to fall through the if's correctly
 # yes, further down we'll do another prasi_login test, it's inefficient, need to clean up
}

}
if($action eq "passexp") {
print "Content-type: text/html\n\n";
# do a silent logout...
my $session = get_session();
if($session eq "") { } else {delete_session($session);}
purge_sessions();
# show mini login screen
login_miniform("$PRASI::lang::msg25");
exit;
}
if($action eq "remoteform") {
print "Content-type: text/html\n\n";
# show mini login screen
login_miniform("$PRASI::lang::msg26r");
exit;
}
if($action eq "badip") {
print "Content-type: text/html\n\n";
# do a silent logout...
my $session = get_session();
if($session eq "") { } else {delete_session($session);}
purge_sessions();
# show mini login screen
login_miniform("$PRASI::lang::msg26");
exit;
}
if($action eq "") {
print "Content-type: text/html\n\n";
# show status incl. login screen if necessary.
my $u=prasi_login("prasi",0);
if(!$initial_user and $u) {$initial_user = $u;}
if($u eq "") {
login_form();
exit;
} else {
pretty_page();
(my $addr) = prasi_data($u,"email");
chomp($addr);
my $wwhen = sprintf "%u",($prasi_session_expires - time())/60 + 1;
if($wwhen > (60*23)) {
$wwhen = sprintf "%u",($wwhen/60)/24 + 1;
$wwhen .= " $PRASI::lang::msg27";
} else {$wwhen .= " $PRASI::lang::msg28";}
(my $wwhere) = prasi_data($u,"ip");
print "
<div id=\"right\">
$PRASI::lang::msg02a$u$PRASI::lang::msg02b$addr$PRASI::lang::msg02c
<br>
$PRASI::lang::msg29 $wwhen.<br>
$PRASI::lang::msg30 $wwhere.
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg31\">
<input type=hidden name=action value=\"logout\"></form>
</div>

<div id=\"box\">
<div id=\"left\">
$PRASI::lang::msg32
</div><div id=\"right\"><b><ul>
";
print_service_list($u);
print "
</ul></b>
</div></div>

<div id =\"box\">
<div id=\"left\">
$PRASI::lang::msg33
</div><div id=\"right\">
$PRASI::lang::msg131<br>
<form action=\"login.cgi\" method=\"post\">
<select name=lang>";
# automatic language selection box
select_lang();
print "
</select>
<input type=submit value=\"$PRASI::lang::msg132\">
<input type=hidden name=action value=\"chglang\"></form>
</div>
<div id=\"right\">
$PRASI::lang::msg34<br>
<form action=\"login.cgi\" method=\"post\">
<input type=password name=pw><input type=submit value=\"$PRASI::lang::msg35\">
<input type=hidden name=action value=\"chgpw\"></form>
</div>
<div id=\"right\">
";
openid_status($u);
print "
</div></div>

<div id=\"box\">
<div id=\"left\">
$PRASI::lang::msg36
</div><div id=\"right\">
<form action=\"login.cgi\" method=\"post\">
<textarea name=m rows=\"10\" cols=\"55\">
$PRASI::lang::msg37
</";
print "textarea><br><input type=submit value=\"$PRASI::lang::msg38\">
<input type=hidden name=action value=\"msg\"></form>
</div></div>

<div id =\"medium\"><center>
$PRASI::lang::msg39 $PRASI::version -- $PRASI::lang::msg40
</center>
</div>
";
exit;
}
}
print "Content-type: text/html\n\n";
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>$PRASI::lang::msg41";
exit;

sub openid_status {
(my $u)=@_;
print "<img src=\"$PRASI::iconwebpath/openid-inputicon.gif\">";
if(-e "$PRASI::datatree/users/$u/openid") {
open(IN,"< $PRASI::datatree/users/$u/openid");
my $oid = <IN>;
close(IN);
chomp($oid);
print "
$PRASI::lang::msg150<br>
<form action=\"login.cgi\" method=\"post\">
ID '$oid' <input type=submit value=\"$PRASI::lang::msg153\">
<input type=hidden name=action value=\"disable-openid\"></form>
";
} else {
print "
$PRASI::lang::msg151<br>
<form action=\"login.cgi\" method=\"post\">
<input type=text size=35 name=oid><input type=submit value=\"$PRASI::lang::msg152\">
<input type=hidden name=action value=\"enable-openid\"></form>
";
}
}

sub get_session {
 # read cookie to find session key claimed.
 my $key = $f->cookie($PRASI::pcook);
 if($key eq "") {
  # do nothing as we simply (downstream) print out the login form
 }
 return $key;
}

sub delete_session {
 # do not report errors - used by silent logout
 (my $d)=@_;
 my $nn="";
 open(IN,"< $PRASI::datatree/prasi_sessions.dat");
 my @li = <IN>;
 close(IN);
 my $ll = "";
 foreach $ll (@li) {
 if($ll=~/(.*):(.*):(.*)/) {
  my $tim = $3;
  my $u=$2;
  my $s=$1;
  if ($d eq $s) {
  } else {
   $nn.="${s}:${u}:${tim}\n";
   }
  } else {
   # do nothing, deletes badly formatted entries eg '\n' alone.
  }
 }
 open(IN,"> $PRASI::datatree/prasi_sessions.dat");
 print IN $nn;
 close(IN);
}

sub authenticate {  # check whether a user is valid
# note we have not printed headers yet!
my $user = $f->param('user');
my $pw = $f->param('pw');
my $oid = $f->param('id');
my $oidret = $f->param('ret');
my $ret = $f->param('return');
my $this_root = "http://".$ENV{'HTTP_HOST'};
my $this_script = "http://".$ENV{'HTTP_HOST'}.$ENV{'SCRIPT_NAME'};
if($oid or $oidret) { #handle an OpenID login
   my $csr = Net::OpenID::Consumer->new(
    ua    => LWP::UserAgent->new,
    cache => undef,
    args  => $f,
    consumer_secret => \&mysecret,
    required_root => $this_root,
  );
  if($oidret) {
  if (my $setup_url = $csr->user_setup_url) {
       print "Content-type: text/html\n\n";
       print "<script>window.location='$setup_url';</script>";
  } elsif ($csr->user_cancel) {
       print "Content-type: text/html\n\n";
       print "<script>window.location='$this_script';</script>";
  } elsif (my $vident = $csr->verified_identity) {
       my $verified_url = $vident->url;
       #print "Content-type: text/html\n\n";
       #print "You are $verified_url ! Ready to go to '$ret'.";
       # check which user has this ID, print the cookie, and proceed merrily.
       my $checkedin = find_openid_user("$verified_url");
       if($checkedin) {
        # all good, print cookie
        # print "Content-type:text/html\n\n";
        # print "you would be user '$checkedin', then!";
        print_cookie_ok("$checkedin","$ret");
        exit;
       } else {
       print "Content-type: text/html\n\n";
       print "$PRASI::lang::msg154";
       #login_error();
       }
  } else {
       #print "Content-type: text/html\n\n";
       #die "Error validating identity: " . $csr->err;
       login_error();
}
exit;
} elsif($oid) {
my $claimed_identity = $csr->claimed_identity($oid);
if(!defined($claimed_identity)) {
        print "Content-type: text/html\n\n";
	print "claim for ",$oid," failed: ", $csr->err;
			exit;
		}
print "Content-type: text/html\n\n";
print "checking OpenID ... ";
my $check_url = $claimed_identity->check_url(return_to=> $this_script."?ret=true&action=login&return=$ret", trust_root => $this_root);
print "<script>window.location='$check_url';</script>";
exit;
} else {login_error();}
exit;
}
if($user eq "") {login_error();}
if($pw eq "") {login_error();}
$pw = main::md5_hex($pw);
# chmod oct("0770"), "$PRASI::datatree/users/$user/password";
open(IN,"< $PRASI::datatree/users/$user/password");
(my $tpw)=<IN>;
close(IN);
if($tpw eq "") {login_error();}
if($tpw ne $pw) {login_error();}
else {
 print_cookie_ok("$user","$ret");
 }
}

sub print_cookie_ok {
# good - print out cookie header
($user,$ret)=@_;
 $new_pw = ''; # GLOBAL
 generate_pw();
 # $new_pw holds new session key
 my $boil = $f->cookie(-name=>$PRASI::pcook,-value=>$new_pw,-path=>'/',-expires=>"+3M");
 print $f->header(-cookie=>$boil);
 #print "Content-type: text/html\n\n";
  my $passexp = $f->param('expires');
  my $t2 = "";
  if($passexp eq "") {$t2 = time()+(2*7*24*60*60);} else {$t2 = time()+$passexp;} # 2 weeks by default
  ensure_single_session($user);  # this removes all sessions for user.
  save_session($user,$new_pw,$passexp);  # yes, passexp, not t2 (is re-computed)
 $new_pw = "0000000000000"; # security...
 if($ret eq "") {
  $ret = "login.cgi?jo=1";
 }
 print "\n\n";
  set_remote_cookies($user,$t2);
  # note we should only proceed with javascript once all images have loaded on this page -- might need some javascript
 pretty_page();
 print "<br><br>$PRASI::lang::msg136\n<br>";
  print "
  <HEAD>
<SCRIPT LANGUAGE=\"JavaScript\"><!--
function loaded() {
    location.href = unescape('$ret');
}
//--></SCRIPT>
</HEAD><BODY onLoad=\"loaded()\">
  $PRASI::lang::msg44<br>
<noscript><a href=\"$ret\">$PRASI::lang::msg45</a></noscript>
</BODY></html>";
 exit;
}

sub login_error {
print "Content-type: text/html\n\n";
pretty_page();
 print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
$PRASI::lang::msg42<br>
<form action=\"login.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg43\">
<input type=hidden name=action value=\"\"></form>
</center></td>
</tr></table>
";
 exit;
}

sub remove_cookie {
# delete the cookie and print the content-type
 my $boil = $f->cookie(-name=>$PRASI::pcook,-value=>'null',-path=>'/',-expires=>"-3M");
 print $f->header(-cookie=>$boil);
}

sub save_session {
 (my $u2,my $s2,my $expires)=@_;
 # save the session key in the file with an expiry
 # also do housekeeping since we have time (login can be slowest procedure)
 purge_sessions();
 my $t2=0;
 if($expires eq "") {$t2 = time()+(2*7*24*60*60);} else {$t2 = time()+$expires;} # 2 weeks by default
 open(IN,">> $PRASI::datatree/prasi_sessions.dat") || die "$PRASI::lang::msg46";
 print IN "$s2:$u2:$t2\n";
 close(IN);
 # save the IP
 if($ENV{'REMOTE_ADDR'} eq "") {die "$PRASI::lang::msg47";}
 open (II,"> $PRASI::datatree/users/$u2/ip") || die "$PRASI::lang::msg48 '$u2'.";
 print II "$ENV{'REMOTE_ADDR'}\n";
 close(II);
}

sub purge_sessions {
 # delete all sessions which are too old
 my $nn="";
 my $u="";
 my $s="";
 open(IN,"< $PRASI::datatree/prasi_sessions.dat");
 my @li = <IN>;
 close(IN);
 my $ll="";
 foreach $ll (@li) {
 if($ll=~/(.*):(.*):(.*)/) {
  my $tim = $3;
  my $u=$2;
  my $s=$1;
  if (time() < $tim) { # still valid
   $nn.="${s}:${u}:${tim}\n";
   }
  } else {
   # do nothing, deletes badly formatted entries eg '\n' alone.
  }
 }
 open(IN,"> $PRASI::datatree/prasi_sessions.dat");
 print IN $nn;
 close(IN);
}

sub ensure_single_session {
 # delete all the user's sessions (only allow one session per user)
 my ($who) = @_;
 my $nn="";
 my $u="";
 my $s="";
 open(IN,"< $PRASI::datatree/prasi_sessions.dat");
 my @li = <IN>;
 close(IN);
 my $ll="";
 foreach $ll (@li) {
 if($ll=~/(.*):(.*):(.*)/) {
  my $tim = $3;
  my $u=$2;
  my $s=$1;
  if ($u eq $who) { # not valid
   # do nothing, deletes entry
   } else {
    $nn.="${s}:${u}:${tim}\n";
   }
  } else {
  # removes badly formatted entries   
  }
 }
 open(IN,"> $PRASI::datatree/prasi_sessions.dat");
 print IN $nn;
 close(IN);
}

sub generate_pw {   # generate a new password
my $password_length = 10;
my @chars = split(" ",
 "a b c d e f g h i j k l m n o p q r s t u v w x y z 
  A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
  0 1 2 3 4 5 6 7 8 9");

srand (time ^ $$ ^ unpack "%L*", `/bin/ps axww | /bin/gzip`);
for ($i=0; $i <= $password_length ;$i++) {
    my $_rand = int(rand 62);
    $new_pw .= $chars[$_rand];
}
}

sub login_form {    # print a user login interface
my $ret = $f->param('return');
$initial_user = '' if (not defined($initial_user));
print "
<STYLE type=\"text/css\">
#prasi { background-color: #C3D9FF;}
body {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; line-height: 
18px; color: #191F11;}
td {  font-size: 11px; line-height: 22px}
h1 {  font-size: 14px; color: #40453D; line-height: 14px; padding: 0px;}
h2 {  font-size: 12px; color: #40453D; line-height: 12px; padding: 0px;}
a {  color: #2C4137; text-decoration: underline;}
td { padding: 4px; border: 1px dashed #639cff; }
input { font-size: 10px; line-height: 10px; }
a:hover {  color: #000000; text-decoration: none;}
#box2 {width: 70%; border: 1px dashed #639cff; padding: 8px;}
 </STYLE>
<br>
<center><a href=\"http://prasi.sourceforge.net\"><img src=\"$PRASI::iconwebpath/prasi_logo.png\" border=0></a><br><br><br>

<form ENCTYPE=\"multipart/form-data\" method=post action=\"login.cgi\" name=f>
$PRASI::lang::msg156
<table border=\"0\">
<tr><td>$PRASI::lang::msg49 
</td><td><input type=text name=\"user\" value=\"${initial_user}\"></td></tr>
<tr><td>$PRASI::lang::msg50 </td><td><input type=password name=\"pw\" value=\"\"></td></tr>
<tr><td>$PRASI::lang::msg51 </td><td><select name=\"expires\">
<option value=\"1209600\" SELECTED>2 $PRASI::lang::msg52</option>
<option value=\"7200\">2 $PRASI::lang::msg53</option>
<option value=\"1800\">30 $PRASI::lang::msg28</option>
</select></td></tr>
<tr><td>$PRASI::lang::msg155 </td><td><input type=text size=35 style=\"background: url($PRASI::iconwebpath/openid-inputicon.gif) no-repeat; background-color: #fff; background-position: 0 50%; padding-left: 18px;\" name=\"id\"></td></tr>
<tr><td></td><td>
<input type=hidden name=action value=login>
<input type=hidden name=return value=$ret>
<input type=submit value=\"$PRASI::lang::msg54\"></td></tr>
<tr><td></td><td>
</table>
</form>
$PRASI::lang::msg55
<br><br>

<div id=\"box2\" align=\"center\">
<h1>$PRASI::lang::msg56</h1>
$PRASI::lang::msg57
<form ENCTYPE=\"multipart/form-data\" method=post action=\"login.cgi\">
<table border=0>
<tr><td>$PRASI::lang::msg49 
</td><td><input type=text name=\"user\" value=\"${initial_user}\"></td></tr>
<tr><td></td><td>
<input type=hidden name=action value=pwforgot>
<input type=submit value=\"$PRASI::lang::msg130\"></td></tr>
<tr><td></td><td>
</table>
</form></div><br>

<div id =\"box2\" align=\"center\">
<h1>$PRASI::lang::msg58</h1>
$PRASI::lang::msg59
<form ENCTYPE=\"multipart/form-data\" method=post action=\"login.cgi\">
<table border=0>
<tr><td>$PRASI::lang::msg60 
</td><td><input type=text name=\"name\" value=\"\"></td></tr>
<tr><td>$PRASI::lang::msg49 
</td><td><input type=text name=\"user\" value=\"\"></td></tr>
<tr><td>$PRASI::lang::msg61 
</td><td><input type=text name=\"email\" value=\"\"></td></tr>
<tr><td>$PRASI::lang::msg62 
</td><td><input type=text name=\"reason\" value=\"-\"></td></tr>
<tr><td></td><td>
<input type=hidden name=action value=newuser>
<input type=submit value=\"$PRASI::lang::msg63\"></td></tr>
<tr><td></td><td>
</table>
</form></div><br />
<br><center>
$PRASI::lang::msg39 $version -- $PRASI::lang::msg40.
</center>
<script>if(!document.f.user.value) {document.f.user.focus();} else {document.f.pw.focus();}</script>
";
}

sub login_miniform {    # print a mini user login interface
my ($dds) = @_; # param must start with <br> to look pretty but not end with it!
my $ret = $f->param('return');
$initial_user = '' if (not defined($initial_user));
print "
<STYLE type=\"text/css\">
#prasi { background-color: #639cff;}
body {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; line-height: 
18px; color: #191F11;}
td {  font-size: 11px; line-height: 22px}
h1 {  font-size: 14px; color: #40453D; line-height: 14px; padding: 0px;}
h2 {  font-size: 12px; color: #40453D; line-height: 12px; padding: 0px;}
a {  color: #2C4137; text-decoration: underline;}
td { padding: 4px; border: 1px dashed #639cff; }
input { font-size: 10px; line-height: 10px; }
a:hover {  color: #000000; text-decoration: none;}
 </STYLE>
<br><br>
<center><a href=\"http://prasi.sourceforge.net\"><img src=\"$PRASI::iconwebpath/prasi_logo.png\" border=0></a><br>
<h1><font color=\"red\"><b>$dds</b></font></h1>
<form method=post action=\"login.cgi\" name=f>
$PRASI::lang::msg156
<table border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\">
<tr><td>$PRASI::lang::msg49 
</td><td><input type=text name=\"user\" value=\"${initial_user}\"></td></tr>
<tr><td>$PRASI::lang::msg50 </td><td><input type=password name=\"pw\" value=\"\"></td></tr>
<tr><td>$PRASI::lang::msg155 </td><td><input type=text size=35 style=\"background: url($PRASI::iconwebpath/openid-inputicon.gif) no-repeat; background-color: #fff; background-position: 0 50%; padding-left: 18px;\" name=\"id\"></td></tr>
<tr><td></td><td>
<input type=hidden name=action value=login>
<input type=hidden name=return value=$ret>
<input type=submit value=\"$PRASI::lang::msg54\"></td></tr>
<tr><td></td><td>
</table></form>
<a href=\"login.cgi?iuser=${initial_user}&return=$ret\">[$PRASI::lang::msg64]</a>
</center>
<script>if(!document.f.user.value) {document.f.user.focus();} else {document.f.pw.focus();}</script>
";
}

sub errorform {
my $ret = $f->param('return');
pretty_page();
print "
<center>
<table width=\"70%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" align=\"center\"><tr>
<td><center>
<form method=post action=\"login.cgi\">
$PRASI::lang::msg65
<form action=$ret><input type=submit value=\"$PRASI::lang::msg19\"></form>
<form action=login.cgi><input type=submit value=\"$PRASI::lang::msg66\"></form>
</center>
</center></td>
</tr></table>
";
}

sub find_openid_user {
(my $url)=@_;
if (opendir(DIR,"$PRASI::datatree/users") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    print "Content-type: text/html\n\n";
    die("$PRASI::lang::msg115");
   }
   my @tfiles = sort @files;
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/users" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {
           if(-e "$PRASI::datatree/users/$fitem/openid") {
open(IN,"< $PRASI::datatree/users/$fitem/openid");
my $oid = <IN>;
close(IN);
chomp($oid);
if($oid eq $url) {return "$fitem";} else {next;}
           }
         }
      }
   }
return "";
}

sub mysecret {
	my $t=shift;
	if(! $t) { $t=time(); print ""; }
	$t -= $t % 3600; # one hour granularity
	$s=main::md5_hex("prasi13openid".($t - $t % 3600));
	return("$s");
}
